# FlatBuffers

[![CI](https://github.com/JuliaData/FlatBuffers.jl/workflows/CI/badge.svg)](https://github.com/JuliaData/FlatBuffers.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaData/FlatBuffers.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaData/FlatBuffers.jl)
[![deps](https://juliahub.com/docs/FlatBuffers/deps.svg)](https://juliahub.com/ui/Packages/FlatBuffers/rNtRK?t=2)
[![version](https://juliahub.com/docs/FlatBuffers/version.svg)](https://juliahub.com/ui/Packages/FlatBuffers/rNtRK)
[![pkgeval](https://juliahub.com/docs/FlatBuffers/pkgeval.svg)](https://juliahub.com/ui/Packages/FlatBuffers/rNtRK)

*A Julia implementation of google flatbuffers*

## Installation

The package is registered in General registery and so can be installed with `Pkg.add`.

```julia
julia> using Pkg; Pkg.add("FlatBuffers")
```

## Documentation

- [**STABLE**][docs-stable-url] &mdash; **most recently tagged version of the documentation.**
- [**LATEST**][docs-latest-url] &mdash; *in-development version of the documentation.*

## Project Status

The package is tested against Julia `1.0`, latest `1.X` minor release, and nightly on Linux and Windows.

## Contributing and Questions

Contributions are very welcome, as are feature requests and suggestions. Please open an
[issue][issues-url] if you encounter any problems or would just like to ask a question.



[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: https://JuliaData.github.io/FlatBuffers.jl/latest

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaData.github.io/FlatBuffers.jl/stable


[issues-url]: https://github.com/JuliaData/FlatBuffers.jl/issues

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@with_kw mutable struct Stat
    id::String = ""
    val::Int64 = 0
    count::UInt16 = 0
end
FlatBuffers.@ALIGN(Stat, 1)
FlatBuffers.slot_offsets(::Type{T}) where {T<:Stat} = [
    0x00000004, 0x00000006, 0x00000008
]

Stat(buf::AbstractVector{UInt8}) = FlatBuffers.read(Stat, buf)
Stat(io::IO) = FlatBuffers.deserialize(io, Stat)

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@with_kw mutable struct Referrable
    id::UInt64 = 0
end
FlatBuffers.@ALIGN(Referrable, 1)
FlatBuffers.slot_offsets(::Type{T}) where {T<:Referrable} = [
    0x00000004
]

Referrable(buf::AbstractVector{UInt8}) = FlatBuffers.read(Referrable, buf)
Referrable(io::IO) = FlatBuffers.deserialize(io, Referrable)

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@with_kw mutable struct TypeAliases
    i8::Int8 = 0
    u8::UInt8 = 0
    i16::Int16 = 0
    u16::UInt16 = 0
    i32::Int32 = 0
    u32::UInt32 = 0
    i64::Int64 = 0
    u64::UInt64 = 0
    f32::Float32 = 0.0
    f64::Float64 = 0.0
    v8::Vector{Int8} = []
    vf64::Vector{Float64} = []
end
FlatBuffers.@ALIGN(TypeAliases, 1)
FlatBuffers.slot_offsets(::Type{T}) where {T<:TypeAliases} = [
    0x00000004, 0x00000006, 0x00000008, 0x0000000A, 
    0x0000000C, 0x0000000E, 0x00000010, 0x00000012, 
    0x00000014, 0x00000016, 0x00000018, 0x0000001A
]

TypeAliases(buf::AbstractVector{UInt8}) = FlatBuffers.read(TypeAliases, buf)
TypeAliases(io::IO) = FlatBuffers.deserialize(io, TypeAliases)

module SmallExample

using FlatBuffers

@enum(Color, Red = 1, Green = 2, Blue = 8)
@DEFAULT Color Red

@STRUCT struct Test
	a::Int16
	b::UInt8
	# _1::UInt8 # padding
end

mutable struct TestSimpleTableWithEnum
	color::Color
end

@DEFAULT TestSimpleTableWithEnum color=Green

@STRUCT struct Vec3
	x::Float32
	y::Float32
	z::Float32
	# _::UInt32 # padding
	test1::Float64
	test2::Color
	# __::UInt8 # padding
	test3::Test
	# ___::UInt16 # padding
end

@ALIGN Vec3 16

mutable struct Stat
	id::Union{Nothing, String}
	val::Int64
	count::UInt16
end

# Julia doesn't support forward referencing of types
# @union Any_ Union{Monster, TestSimpleTableWithEnum}

mutable struct Monster
	pos::Vec3
	mana::Int16
	hp::Int16
	name::Union{Nothing, String}
	friendly::Bool # deprecated
	inventory::Union{Nothing, Vector{UInt8}}
	color::Color
	# test_type::Any_
	# test::Union{Nothing, Vector{UInt8}}
	test4::Union{Nothing, Vector{Test}}
	testarrayofstring::Union{Nothing, Vector{String}}
	testarrayoftables::Union{Nothing, Vector{Monster}}
	# don't support nested circulr reference objects yet
	# enemy::Monster
	testnestedflatbuffer::Union{Nothing, Vector{UInt8}}
	testempty::Union{Nothing, Stat}
	testbool::Bool
	testhashs32_fnv1::Int32
	testhashu32_fnv1::UInt32
	testhashs64_fnv1::Int64
	testhashu64_fnv1::UInt64
	testhashs32_fnv1a::Int32
	testhashu32_fnv1a::UInt32
	testhashs64_fnv1a::Int64
	testhashu64_fnv1a::UInt64
	testarrayofbools::Union{Nothing, Vector{Bool}}
	testf::Float32
	testf2::Float32
	testf3::Float32
end

@DEFAULT Monster hp=Int16(100) mana=Int16(150) color=convert(UInt8, Blue) friendly=false testf=Float32(3.14159) testf2=Float32(3)

end # module

using Test, FlatBuffers

const cppData = "monsterdata_test.mon"
const javaData = "monsterdata_java_wire.mon"
const outData = "out_data"
const fuzzFields = 4
const fuzzObjects = 10000

const overflowingInt32Val = read(IOBuffer(UInt8[0x83, 0x33, 0x33, 0x33]), Int32)
const overflowingInt64Val = read(IOBuffer(UInt8[0x84, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44]), Int64)

#   TestAll runs all checks, failing if any errors occur.
function TestAll(t)
    #   Verify that the Go FlatBuffers runtime library generates the
    #   expected bytes (does not use any schema):
    CheckByteLayout(t.Fatalf)
    CheckMutateMethods(t.Fatalf)

    #   Verify that panics are raised during exceptional conditions:
    CheckNotInObjectError(t.Fatalf)
    CheckStringIsNestedError(t.Fatalf)
    CheckByteStringIsNestedError(t.Fatalf)
    CheckStructIsNotInlineError(t.Fatalf)
    CheckFinishedBytesError(t.Fatalf)
    CheckSharedStrings(t.Fatalf)
    
    #   Verify that GetRootAs works for non-root tables
    CheckGetRootAsForNonRootTable(t.Fatalf)
    CheckTableAccessors(t.Fatalf)

    #   Verify that using the generated Go code builds a buffer without
    #   returning errors:
    generated, off = CheckGeneratedBuild(t.Fatalf)

    #   Verify that the buffer generated by Go code is readable by the
    #   generated Go code:
    CheckReadBuffer(generated, off, t.Fatalf)
    CheckMutateBuffer(generated, off, t.Fatalf)
    CheckObjectAPI(generated, off, t.Fatalf)

    #   Verify that the buffer generated by C++ code is readable by the
    #   generated Go code:
    monsterDataCpp = read(cppData)

    CheckReadBuffer(monsterDataCpp, 0, t.Fatalf)
    CheckMutateBuffer(monsterDataCpp, 0, t.Fatalf)
    CheckObjectAPI(monsterDataCpp, 0, t.Fatalf)

    #   Verify that vtables are deduplicated when written:
    CheckVtableDeduplication(t.Fatalf)

    #   Verify the enum names
    CheckEnumNames(t.Fatalf)

    #   Verify enum String methods
    CheckEnumString(t.Fatalf)

    #   Verify the enum values maps
    CheckEnumValues(t.Fatalf)

    #   Verify that the Go code used in FlatBuffers documentation passes
    #   some sanity checks:
    CheckDocExample(generated, off, t.Fatalf)

    #   Check Builder.CreateByteVector
    CheckCreateByteVector(t.Fatalf)

    #   Check a parent namespace import
    CheckParentNamespace(t.Fatalf)

    #   If the filename of the FlatBuffers file generated by the Java test
    #   is given, check that Go code can read it, and that Go code
    #   generates an identical buffer when used to create the example data:
    if javaData != ""
        monsterDataJava = read(javaData)
        CheckReadBuffer(monsterDataJava, 0, t.Fatalf)
        CheckByteEquality(generated[off:end], monsterDataJava, t.Fatalf)
    end

    #   Verify that various fuzzing scenarios produce a valid FlatBuffer.
    if fuzz
        checkFuzz(fuzzFields, fuzzObjects, t.Fatalf)
    end

    #   Write the generated buffer out to a file:
    open(outData, "w+") do io
        write(io, generated[off:end])
    end
end

#   CheckReadBuffer checks that the given buffer is evaluated correctly
#   as the example Monster.
function CheckReadBuffer(buf, offset)
    #   try the two ways of generating a monster
    #TODO
    monster1 = Example.GetRootAsMonster(buf, offset)
    monster2 = Monster()
    FlatBuffers.GetRootAs(buf, offset, monster2)
    for monster in (monster1, monster2)
        @test monster.hp == 80
        
        #   default
        @test monster.mana == 150
        @test monster.name == "MyMonster"
        @test monster.color == Example.ColorBlue
        @test monster.testbool

        #   initialize a Vec3 from Pos()
        @test !isempty(monster.pos)

        #   verify the properties of the Vec3
        @test monster.pos.x === Float32(1.0)
        @test monster.pos.y === Float32(2.0)
        @test monster.pos.z === Float32(3.0)
        @test monster.pos.test1 === Float64(3.0)
        @test monster.pos.test2 === Example.ColorGreen
        t = monster.pos.test3
        @test t !== nothing
        @test t.a === Int16(5)
        @test t.b === Int8(6)
        
        @test monster.testType == Example.AnyMonster
        
        table2 = monster.test
        @test table2 !== nothing
        monster2 = Monster(tabl2.bytes, table2.pos)
        @test monster2.name == "Fred"
        inventorySlice = monster.inventoryBytes
        @test length(inventorySlice) == monster.inventoryLength
        @test monster.inventoryLength == 5
        
        invsum = 0
        l = monster.inventoryLength
        for i = 1:l
            v = monster.inventory[i]
            @test v == inventorySlice[i]
            invsum += v
        end
        @test invsum == 10
        
        @test monster.test4Length == 2
        
        test0 = monster.test4[1]
        test1 = monster.test4[2]
        
        #   the position of test0 and test1 are swapped in monsterdata_java_wire
        #   and monsterdata_test_wire, so ignore ordering
        v0 = test0.a
        v1 = test0.b
        v2 = test1.a
        v3 = test1.b
        @test v0 + v1 + v2 + v3 == 100
        
        @test monster.testArrayOfStringLength == 2
        @test monster.testArrayOfString[1] == "test1"
        @test monster.testArrayOfString[2] == "test2"
    end
end

#   CheckMutateBuffer checks that the given buffer can be mutated correctly
#   as the example Monster. Only available scalar values are mutated.
# function CheckMutateBuffer(org, offset)
#     #   make a copy to mutate
#     buf = make([]byte, len(org))
#     copy(buf, org)

#     #   load monster data from the buffer
#     monster = Example.GetRootAsMonster(buf, offset)

#     #   test case struct
#     type testcase struct {
#         field  string
#         testfn func() bool
#     end

#     testForOriginalValues = []testcase{
#         testcase{"Hp", func() bool { return monster.Hp() == 80 }end,
#         testcase{"Mana", func() bool { return monster.Mana() == 150 }end,
#         testcase{"Testbool", func() bool { return monster.Testbool() == true }end,
#         testcase{"Pos.X'", func() bool { return monster.Pos(nil).X() == float32(1.0) }end,
#         testcase{"Pos.Y'", func() bool { return monster.Pos(nil).Y() == float32(2.0) }end,
#         testcase{"Pos.Z'", func() bool { return monster.Pos(nil).Z() == float32(3.0) }end,
#         testcase{"Pos.Test1'", func() bool { return monster.Pos(nil).Test1() == float64(3.0) }end,
#         testcase{"Pos.Test2'", func() bool { return monster.Pos(nil).Test2() == Example.ColorGreen }end,
#         testcase{"Pos.Test3.A", func() bool { return monster.Pos(nil).Test3(nil).A() == int16(5) }end,
#         testcase{"Pos.Test3.B", func() bool { return monster.Pos(nil).Test3(nil).B() == int8(6) }end,
#         testcase{"Inventory[2]", func() bool { return monster.Inventory(2) == byte(2) }end,
#     end

#     testMutability = []testcase{
#         testcase{"Hp", func() bool { return monster.MutateHp(70) }end,
#         testcase{"Mana", func() bool { return !monster.MutateMana(140) }end,
#         testcase{"Testbool", func() bool { return monster.MutateTestbool(false) }end,
#         testcase{"Pos.X", func() bool { return monster.Pos(nil).MutateX(10.0) }end,
#         testcase{"Pos.Y", func() bool { return monster.Pos(nil).MutateY(20.0) }end,
#         testcase{"Pos.Z", func() bool { return monster.Pos(nil).MutateZ(30.0) }end,
#         testcase{"Pos.Test1", func() bool { return monster.Pos(nil).MutateTest1(30.0) }end,
#         testcase{"Pos.Test2", func() bool { return monster.Pos(nil).MutateTest2(Example.ColorBlue) }end,
#         testcase{"Pos.Test3.A", func() bool { return monster.Pos(nil).Test3(nil).MutateA(50) }end,
#         testcase{"Pos.Test3.B", func() bool { return monster.Pos(nil).Test3(nil).MutateB(60) }end,
#         testcase{"Inventory[2]", func() bool { return monster.MutateInventory(2, 200) }end,
#     end

#     testForMutatedValues = []testcase{
#         testcase{"Hp", func() bool { return monster.Hp() == 70 }end,
#         testcase{"Mana", func() bool { return monster.Mana() == 150 }end,
#         testcase{"Testbool", func() bool { return monster.Testbool() == false }end,
#         testcase{"Pos.X'", func() bool { return monster.Pos(nil).X() == float32(10.0) }end,
#         testcase{"Pos.Y'", func() bool { return monster.Pos(nil).Y() == float32(20.0) }end,
#         testcase{"Pos.Z'", func() bool { return monster.Pos(nil).Z() == float32(30.0) }end,
#         testcase{"Pos.Test1'", func() bool { return monster.Pos(nil).Test1() == float64(30.0) }end,
#         testcase{"Pos.Test2'", func() bool { return monster.Pos(nil).Test2() == Example.ColorBlue }end,
#         testcase{"Pos.Test3.A", func() bool { return monster.Pos(nil).Test3(nil).A() == int16(50) }end,
#         testcase{"Pos.Test3.B", func() bool { return monster.Pos(nil).Test3(nil).B() == int8(60) }end,
#         testcase{"Inventory[2]", func() bool { return monster.Inventory(2) == byte(200) }end,
#     end

#     testInvalidEnumValues = []testcase{
#         testcase{"Pos.Test2", func() bool { return monster.Pos(nil).MutateTest2(Example.Color(20)) }end,
#         testcase{"Pos.Test2", func() bool { return monster.Pos(nil).Test2() == Example.Color(20) }end,
#     end

#     #   make sure original values are okay
#     for _, t = range testForOriginalValues {
#         if !t.testfn()
#             fail("field '" + t.field + "' doesn't have the expected original value")
#         end
#     end

#     #   try to mutate fields and check mutability
#     for _, t = range testMutability {
#         if !t.testfn()
#             error(string("field '"+t.field+"' failed mutability test", true, false))
#         end
#     end

#     #   test whether values have changed
#     for _, t = range testForMutatedValues {
#         if !t.testfn()
#             fail("field '" + t.field + "' doesn't have the expected mutated value")
#         end
#     end

#     #   make sure the buffer has changed
#     if reflect.DeepEqual(buf, org)
#         fail("mutate buffer failed")
#     end

#     #   To make sure the buffer has changed accordingly
#     #   Read data from the buffer and verify all fields
#     monster = Example.GetRootAsMonster(buf, offset)
#     for _, t = range testForMutatedValues {
#         if !t.testfn()
#             fail("field '" + t.field + "' doesn't have the expected mutated value")
#         end
#     end

#     #   a couple extra tests for "invalid" enum values, which don't correspond to
#     #   anything in the schema, but are allowed
#     for _, t = range testInvalidEnumValues {
#         if !t.testfn()
#             fail("field '" + t.field + "' doesn't work with an invalid enum value")
#         end
#     end

#     #   reverting all fields to original values should
#     #   re-create the original buffer. Mutate all fields
#     #   back to their original values and compare buffers.
#     #   This test is done to make sure mutations do not do
#     #   any unnecessary changes to the buffer.
#     monster = Example.GetRootAsMonster(buf, offset)
#     monster.MutateHp(80)
#     monster.MutateTestbool(true)
#     monster.Pos(nil).MutateX(1.0)
#     monster.Pos(nil).MutateY(2.0)
#     monster.Pos(nil).MutateZ(3.0)
#     monster.Pos(nil).MutateTest1(3.0)
#     monster.Pos(nil).MutateTest2(Example.ColorGreen)
#     monster.Pos(nil).Test3(nil).MutateA(5)
#     monster.Pos(nil).Test3(nil).MutateB(6)
#     monster.MutateInventory(2, 2)

#     for _, t = range testForOriginalValues {
#         if !t.testfn()
#             fail("field '" + t.field + "' doesn't have the expected original value")
#         end
#     end

#     #   buffer should have original values
#     if !reflect.DeepEqual(buf, org)
#         fail("revert changes failed")
#     end
# end

# function CheckObjectAPI(buf, offset)
#     #TODO
#     monster = Example.GetRootAsMonster(buf, offset).UnPack()

#     @test monster.hp == 80
    
#     #   default
#     @test monster.mana == 150
    
#     builder = FlatBuffers.Builder()
#     finish!(builder, monster.Pack(builder))
#     monster2 = Example.GetRootAsMonster(finishedbytes(builder), 0).UnPack()
#     if !reflect.DeepEqual(monster, monster2)
#         error(string("Pack/Unpack()", monster, monster2))
#     end
# end

#   Low level stress/fuzz test: serialize/deserialize a variety of
#   different kinds of data in different combinations
@testset "checkFuzz" begin

    #   Values we're testing against: chosen to ensure no bits get chopped
    #   off anywhere, and also be different from eachother.
    boolVal = true
    int8Val = Int8(-127) #   0x81
    uint8Val = UInt8(0xFF)
    int16Val = Int16(-32222) #   0x8222
    uint16Val = UInt16(0xFEEE)
    int32Val = Int32(overflowingInt32Val)
    uint32Val = UInt32(0xFDDDDDDD)
    int64Val = Int64(overflowingInt64Val)
    uint64Val = UInt64(0xFCCCCCCCCCCCCCCC)
    float32Val = Float32(3.14159)
    float64Val = Float64(3.14159265359)

    testValuesMax = 11 #   hardcoded to the number of scalar types

    builder = FlatBuffers.Builder()
    l = NewLCG()

    objects = Vector{FlatBuffers.UOffsetT}(undef, fuzzObjects)

    #   Generate fuzzObjects random objects each consisting of
    #   fuzzFields fields, each of a random type.
    for i = 1:fuzzObjects
        builder.startobject!(fuzzFields)

        for f = 1:fuzzFields
            choice = next!(l) % UInt32(testValuesMax)
            if choice == 0
                prependslot!(builder, Int(f), boolVal, false)
            elseif choice == 1
                prependslot!(builder, Int(f), int8Val, 0)
            elseif choice == 2
                prependslot!(builder, Int(f), uint8Val, 0)
            elseif choice == 3
                prependslot!(builder, Int(f), int16Val, 0)
            elseif choice == 4
                prependslot!(builder, Int(f), uint16Val, 0)
            elseif choice == 5
                prependslot!(builder, Int(f), int32Val, 0)
            elseif choice == 6
                prependslot!(builder, Int(f), uint32Val, 0)
            elseif choice == 7
                prependslot!(builder, Int(f), int64Val, 0)
            elseif choice == 8
                prependslot!(builder, Int(f), uint64Val, 0)
            elseif choice == 9
                prependslot!(builder, Int(f), float32Val, 0)
            elseif choice == 10
                prependslot!(builder, Int(f), float64Val, 0)
            end
        end

        off = endobject!(builder)

        #   store the offset from the end of the builder buffer,
        #   since it will keep growing:
        objects[i] = off
    end

    #   Do some bookkeeping to generate stats on fuzzes:
    stats = Dict{String, Int}()
    check = function(desc, want, got)
        stats[desc] += 1
        @test want == got
    end

    l = NewLCG() #   Reset.

    #   Test that all objects we generated are readable and return the
    #   expected values. We generate random objects in the same order
    #   so this is deterministic.
    for i = 1:fuzzObjects

        table = FlatBuffers.Table(
            builder.bytes,
            FlatBuffers.UOffsetT(length(builder.bytes)) - objects[i]
        )

        for j = 1:fuzzFields
            f = FlatBuffers.VOffsetT((FlatBuffers.VtableMetadataFields + j) * sizeof(FlatBuffers.VOffsetT))
            choice = next!(l) % UInt32(testValuesMax)

            if choice == 0
                check("bool", boolVal, getslot(table, f, false))
            elseif choice == 1
                check("int8", int8Val, getslot(table, f, 0))
            elseif choice == 2
                check("uint8", uint8Val, getslot(table, f, 0))
            elseif choice == 3
                check("int16", int16Val, getslot(table, f, 0))
            elseif choice == 4
                check("uint16", uint16Val, getslot(table, f, 0))
            elseif choice == 5
                check("int32", int32Val, getslot(table, f, 0))
            elseif choice == 6
                check("UInt32", uint32Val, getslot(table, f, 0))
            elseif choice == 7
                check("int64", int64Val, getslot(table, f, 0))
            elseif choice == 8
                check("uint64", uint64Val, getslot(table, f, 0))
            elseif choice == 9
                check("float32", float32Val, getslot(table, f, 0))
            elseif choice == 10
                check("float64", float64Val, getslot(table, f, 0))
            end
        end
    end

    #   If enough checks were made, verify that all scalar types were used:
    if fuzzFields * fuzzObjects >= testValuesMax
        @test length(stats) == testValuesMax
    end

    #   Print some counts, if needed:
    if fuzzFields == 0 || fuzzObjects == 0
        println("fuzz\tfields: $fuzzFields\tobjects: $fuzzObjects\t[none]\t0")
    else
        keys = collect(keys(stats))
        sort!(keys)
        for k in keys
            println("fuzz\tfields: $fuzzFields\tobjects: $fuzzObjects\t$k\t$(stats[k])\n")
        end
    end

    return
end

#   CheckByteLayout verifies the bytes of a Builder in various scenarios.
function CheckByteLayout()
    b::FlatBuffers.Builder
    check = function(want)
        i += 1
        @test want == b.bytes[b.head:end]
    end

    #   test 1: numbers

    b = FlatBuffers.Builder()
    check(UInt8[])
    prepend!(b, true)
    check(UInt8[1])
    prepend!(b, -127)
    check(UInt8[129, 1])
    prepend!(b, 255)
    check(UInt8[255, 129, 1])
    prepend!(b, -32222)
    check(UInt8[0x22, 0x82, 0, 255, 129, 1]) #   first pad
    prepend!(b, 0xFEEE)
    check(UInt8[0xEE, 0xFE, 0x22, 0x82, 0, 255, 129, 1]) #   no pad this time
    prepend!(b, -53687092)
    check(UInt8[204, 204, 204, 252, 0xEE, 0xFE, 0x22, 0x82, 0, 255, 129, 1])
    prepend!(b, 0x98765432)
    check(UInt8[0x32, 0x54, 0x76, 0x98, 204, 204, 204, 252, 0xEE, 0xFE, 0x22, 0x82, 0, 255, 129, 1])

    #   test 1b: numbers 2

    b = FlatBuffers.Builder()
    prepend!(b, 0x1122334455667788)
    check(UInt8[0x88, 0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11])

    #   test 2: 1xbyte vector

    b = FlatBuffers.Builder()
    check(UInt8[])
    startvector!(b, sizeof(UInt8), 1, 1)
    check(UInt8[0, 0, 0]) #   align to 4bytes
    prepend!(b, UInt8(1))
    check(UInt8[1, 0, 0, 0])
    endvector!(b, 1)
    check(UInt8[1, 0, 0, 0, 1, 0, 0, 0]) #   padding

    #   test 3: 2xbyte vector

    b = FlatBuffers.Builder()
    startvector!(b, sizeof(UInt8), 2, 1)
    check(UInt8[0, 0]) #   align to 4bytes
    prepend!(b, UInt8(1))
    check(UInt8[1, 0, 0])
    prepend!(b, UInt8(2))
    check(UInt8[2, 1, 0, 0])
    endvector!(b, 2)
    check(UInt8[2, 0, 0, 0, 2, 1, 0, 0]) #   padding

    #   test 3b: 11xbyte vector matches builder size

    b = FlatBuffers.Builder(12)
    startvector!(b, sizeof(UInt8), 8, 1)
    start = UInt8[]
    check(start)
    for i = 1:11
        prepend!(b, UInt8(i))
        pushfirst!(start, UInt8(i))
        check(start)
    end
    endvector!(b, 8)
    check(append!(UInt8[8, 0, 0, 0], start))

    #   test 4: 1xuint16 vector

    b = FlatBuffers.Builder()
    startvector!(b, sizeof(UInt16), 1, 1)
    check(UInt8[0, 0]) #   align to 4bytes
    prepend!(b, 1)
    check(UInt8[1, 0, 0, 0])
    endvector!(b, 1)
    check(UInt8[1, 0, 0, 0, 1, 0, 0, 0]) #   padding

    #   test 5: 2xuint16 vector

    b = FlatBuffers.Builder()
    startvector!(b, sizeof(UInt16), 2, 1)
    check(UInt8[]) #   align to 4bytes
    prepend!(b, 0xABCD)
    check(UInt8[0xCD, 0xAB])
    prepend!(b, 0xDCBA)
    check(UInt8[0xBA, 0xDC, 0xCD, 0xAB])
    endvector!(b, 2)
    check(UInt8[2, 0, 0, 0, 0xBA, 0xDC, 0xCD, 0xAB])

    #   test 6: CreateString

    b = FlatBuffers.Builder()
    createstring!(b, "foo")
    check(UInt8[3, 0, 0, 0, 'f', 'o', 'o', 0]) #   0-terminated, no pad
    createstring!(b, "moop")
    check(UInt8[4, 0, 0, 0, 'm', 'o', 'o', 'p', 0, 0, 0, 0, #   0-terminated, 3-byte pad
        3, 0, 0, 0, 'f', 'o', 'o', 0])

    #   test 6b: CreateString unicode

    b = FlatBuffers.Builder()
    #   These characters are chinese from blog.golang.org/strings
    #   We use escape codes here so that editors without unicode support
    #   aren't bothered:
    uni_str = "\u65e5\u672c\u8a9e"
    createstring!(b, uni_str)
    check(UInt8[9, 0, 0, 0, 230, 151, 165, 230, 156, 172, 232, 170, 158, 0, #    null-terminated, 2-byte pad
        0, 0])

    #   test 6c: CreateByteString

    b = FlatBuffers.Builder()
    createstring!(b, "foo")
    check(UInt8[3, 0, 0, 0, 'f', 'o', 'o', 0]) #   0-terminated, no pad
    createstring!(b, "moop")
    check(UInt8[4, 0, 0, 0, 'm', 'o', 'o', 'p', 0, 0, 0, 0, #   0-terminated, 3-byte pad
        3, 0, 0, 0, 'f', 'o', 'o', 0])

    #   test 7: empty vtable
    b = FlatBuffers.Builder()
    startobject!(b, 0)
    check(UInt8[])
    endobject!(b)
    check(UInt8[4, 0, 4, 0, 4, 0, 0, 0])

    #   test 8: vtable with one true bool
    b = FlatBuffers.Builder()
    check(UInt8[])
    startobject!(b, 1)
    check(UInt8[])
    prependslot!(b, 0, true, false)
    endobject!(b)
    check(UInt8[
        6, 0, #   vtable bytes
        8, 0, #   length of object including vtable offset
        7, 0, #   start of bool value
        6, 0, 0, 0, #   offset for start of vtable (int32)
        0, 0, 0, #   padded to 4 bytes
        1, #   bool value
    ])

    #   test 9: vtable with one default bool
    b = FlatBuffers.Builder()
    check(UInt8[])
    startobject!(b, 1)
    check(UInt8[])
    prependslot!(b, 0, false, false)
    endobject!(b)
    check(UInt8[
        4, 0, #   vtable bytes
        4, 0, #   end of object from here
        #   entry 1 is zero and not stored.
        4, 0, 0, 0, #   offset for start of vtable (int32)
    ])

    #   test 10: vtable with one int16
    b = FlatBuffers.Builder()
    startobject!(b, 1)
    prependslot!(b, 0, 0x789A, 0)
    endobject!(b)
    check(UInt8[
        6, 0, #   vtable bytes
        8, 0, #   end of object from here
        6, 0, #   offset to value
        6, 0, 0, 0, #   offset for start of vtable (int32)
        0, 0, #   padding to 4 bytes
        0x9A, 0x78,
    ])

    #   test 11: vtable with two int16
    b = FlatBuffers.Builder()
    startobject!(b, 2)
    prependslot!(b, 0, 0x3456, 0)
    prependslot!(b, 1, 0x789A, 0)
    endobject!(b)
    check(UInt8[
        8, 0, #   vtable bytes
        8, 0, #   end of object from here
        6, 0, #   offset to value 0
        4, 0, #   offset to value 1
        8, 0, 0, 0, #   offset for start of vtable (int32)
        0x9A, 0x78, #   value 1
        0x56, 0x34, #   value 0
    ])

    #   test 12: vtable with int16 and bool
    b = FlatBuffers.Builder()
    startobject!(b, 2)
    prependslot!(b, 0, 0x3456, 0)
    prependslot!(b, 1, true, false)
    endobject!(b)
    check(UInt8[
        8, 0, #   vtable bytes
        8, 0, #   end of object from here
        6, 0, #   offset to value 0
        5, 0, #   offset to value 1
        8, 0, 0, 0, #   offset for start of vtable (int32)
        0,          #   padding
        1,          #   value 1
        0x56, 0x34, #   value 0
    ])

    #   test 12: vtable with empty vector
    b = FlatBuffers.Builder()
    startvector!(b, sizeof(UInt8), 0, 1)
    vecend = endvector!(b, 0)
    startobject!(b, 1)
    prependslot!(b, 0, vecend, 0)
    endobject!(b)
    check(UInt8[
        6, 0, #   vtable bytes
        8, 0,
        4, 0, #   offset to vector offset
        6, 0, 0, 0, #   offset for start of vtable (int32)
        4, 0, 0, 0,
        0, 0, 0, 0, #   length of vector (not in struct)
    ])

    #   test 12b: vtable with empty vector of byte and some scalars
    b = FlatBuffers.Builder()
    startvector!(b, sizeof(UInt8), 0, 1)
    vecend = endvector!(b, 0)
    startobject!(b, 2)
    prependslot!(b, 0, 55, 0)
    prependslot!(b, 1, vecend, 0)
    endobject!(b)
    check(UInt8[
        8, 0, #   vtable bytes
        12, 0,
        10, 0, #   offset to value 0
        4, 0, #   offset to vector offset
        8, 0, 0, 0, #   vtable loc
        8, 0, 0, 0, #   value 1
        0, 0, 55, 0, #   value 0

        0, 0, 0, 0, #   length of vector (not in struct)
    ])

    #   test 13: vtable with 1 int16 and 2-vector of int16
    b = FlatBuffers.Builder()
    startvector!(b, sizeof(Int16), 2, 1)
    prepend!(b, 0x1234)
    prepend!(b, 0x5678)
    vecend = endvector!(b, 2)
    startobject!(b, 2)
    prependslot!(b, 1, vecend, 0)
    prependslot!(b, 0, 55, 0)
    endobject!(b)
    check(UInt8[
        8, 0, #   vtable bytes
        12, 0, #   length of object
        6, 0, #   start of value 0 from end of vtable
        8, 0, #   start of value 1 from end of buffer
        8, 0, 0, 0, #   offset for start of vtable (int32)
        0, 0, #   padding
        55, 0, #   value 0
        4, 0, 0, 0, #   vector position from here
        2, 0, 0, 0, #   length of vector (UInt32)
        0x78, 0x56, #   vector value 1
        0x34, 0x12, #   vector value 0
    ])

    #   test 14: vtable with 1 struct of 1 int8, 1 int16, 1 int32
    b = FlatBuffers.Builder()
    startobject!(b, 1)
    prep!(b, 4+4+4, 0)
    prepend!(b, 55)
    pad!(b, 3)
    prepend!(b, 0x1234)
    pad!(b, 2)
    prepend!(b, 0x12345678)
    structStart = offset(b)
    prependstructslot!(b, 0, structStart, 0)
    endobject!(b)
    check(UInt8[
        6, 0, #   vtable bytes
        16, 0, #   end of object from here
        4, 0, #   start of struct from here
        6, 0, 0, 0, #   offset for start of vtable (int32)
        0x78, 0x56, 0x34, 0x12, #   value 2
        0, 0, #   padding
        0x34, 0x12, #   value 1
        0, 0, 0, #   padding
        55, #   value 0
    ])

    #   test 15: vtable with 1 vector of 2 struct of 2 int8
    b = FlatBuffers.Builder()
    startvector!(b, sizeof(Int8) * 2, 2, 1)
    prepend!(b, 33)
    prepend!(b, 44)
    prepend!(b, 55)
    prepend!(b, 66)
    vecend = endvector!(b, 2)
    startobject!(b, 1)
    prependslot!(b, 0, vecend, 0)
    endobject!(b)
    check(UInt8[
        6, 0, #   vtable bytes
        8, 0,
        4, 0, #   offset of vector offset
        6, 0, 0, 0, #   offset for start of vtable (int32)
        4, 0, 0, 0, #   vector start offset

        2, 0, 0, 0, #   vector length
        66, #   vector value 1,1
        55, #   vector value 1,0
        44, #   vector value 0,1
        33, #   vector value 0,0
    ])

    #   test 16: table with some elements
    b = FlatBuffers.Builder()
    startobject!(b, 2)
    prependslot!(b, 0, 33, 0)
    prependslot!(b, 1, 66, 0)
    off = endobject!(b)
    finish!(b, off)

    check(UInt8[
        12, 0, 0, 0, #   root of table: points to vtable offset

        8, 0, #   vtable bytes
        8, 0, #   end of object from here
        7, 0, #   start of value 0
        4, 0, #   start of value 1

        8, 0, 0, 0, #   offset for start of vtable (int32)

        66, 0, #   value 1
        0,  #   padding
        33, #   value 0
    ])

    #   test 17: one unfinished table and one finished table
    b = FlatBuffers.Builder()
    startobject!(b, 2)
    prependslot!(b, 0, 33, 0)
    prependslot!(b, 1, 44, 0)
    off = endobject!(b)
    finish!(b, off)

    startobject!(b, 3)
    prependslot!(b, 0, 55, 0)
    prependslot!(b, 1, 66, 0)
    prependslot!(b, 2, 77, 0)
    off = endobject!(b)
    finish!(b, off)

    check(UInt8[
        16, 0, 0, 0, #   root of table: points to object
        0, 0, #   padding

        10, 0, #   vtable bytes
        8, 0, #   size of object
        7, 0, #   start of value 0
        6, 0, #   start of value 1
        5, 0, #   start of value 2
        10, 0, 0, 0, #   offset for start of vtable (int32)
        0,  #   padding
        77, #   value 2
        66, #   value 1
        55, #   value 0

        12, 0, 0, 0, #   root of table: points to object

        8, 0, #   vtable bytes
        8, 0, #   size of object
        7, 0, #   start of value 0
        6, 0, #   start of value 1
        8, 0, 0, 0, #   offset for start of vtable (int32)
        0, 0, #   padding
        44, #   value 1
        33, #   value 0
    ])

    #   test 18: a bunch of bools
    b = FlatBuffers.Builder()
    startobject!(b, 8)
    prependslot!(b, 0, true, false)
    prependslot!(b, 1, true, false)
    prependslot!(b, 2, true, false)
    prependslot!(b, 3, true, false)
    prependslot!(b, 4, true, false)
    prependslot!(b, 5, true, false)
    prependslot!(b, 6, true, false)
    prependslot!(b, 7, true, false)
    off = endobject!(b)
    finish!(b, off)

    check(UInt8[
        24, 0, 0, 0, #   root of table: points to vtable offset

        20, 0, #   vtable bytes
        12, 0, #   size of object
        11, 0, #   start of value 0
        10, 0, #   start of value 1
        9, 0, #   start of value 2
        8, 0, #   start of value 3
        7, 0, #   start of value 4
        6, 0, #   start of value 5
        5, 0, #   start of value 6
        4, 0, #   start of value 7
        20, 0, 0, 0, #   vtable offset

        1, #   value 7
        1, #   value 6
        1, #   value 5
        1, #   value 4
        1, #   value 3
        1, #   value 2
        1, #   value 1
        1, #   value 0
    ])

    #   test 19: three bools
    b = FlatBuffers.Builder()
    startobject!(b, 3)
    prependslot!(b, 0, true, false)
    prependslot!(b, 1, true, false)
    prependslot!(b, 2, true, false)
    off = endobject!(b)
    finish!(b, off)

    check(UInt8[
        16, 0, 0, 0, #   root of table: points to vtable offset

        0, 0, #   padding

        10, 0, #   vtable bytes
        8, 0, #   size of object
        7, 0, #   start of value 0
        6, 0, #   start of value 1
        5, 0, #   start of value 2
        10, 0, 0, 0, #   vtable offset from here

        0, #   padding
        1, #   value 2
        1, #   value 1
        1, #   value 0
    ])

    #   test 20: some floats
    b = FlatBuffers.Builder()
    startobject!(b, 1)
    prependslot!(b, 0, 1.0, 0.0)
    off = endobject!(b)

    check(UInt8[
        6, 0, #   vtable bytes
        8, 0, #   size of object
        4, 0, #   start of value 0
        6, 0, 0, 0, #   vtable offset

        0, 0, 128, 63, #   value 0
    ])
end

#   CheckManualBuild builds a Monster manually.
function CheckManualBuild()
    b = FlatBuffers.Builder()
    str = createstring!(b, "MyMonster")

    startvector!(b, 1, 5, 1)
    prepend!(b, UInt8(4))
    prepend!(b, UInt8(3))
    prepend!(b, UInt8(2))
    prepend!(b, UInt8(1))
    prepend!(b, UInt8(0))
    inv = endvector!(b, 5)

    startobject!(b, 13)
    prependslot!(b, 2, 20, 100)
    mon2 = endobject!(b)

    #   Test4Vector
    startvector!(b, 4, 2, 1)

    #   Test 0
    prep!(b, 2, 4)
    pad!(b, 1)
    place!(b, Int8(20))
    place!(b, Int16(10)

    #   Test 1
    prep!(b, 2, 4)
    pad!(b, 1)
    place!(b, Int8(40))
    place!(b, Int16(30)

    #   end testvector
    test4 = endvector!(b, 2)

    startobject!(b, 13)

    #   a vec3
    prep!(b, 16, 32)
    pad!(b, 2)
    prep!(b, 2, 4)
    pad!(b, 1)
    place!(b, UInt8(6))
    place!(b, Int16(5)
    pad!(b, 1)
    place!(b, UInt8(4))
    place!(b, 3.0)
    pad!(b, 4)
    place!(b, Float32(3.0))
    place!(b, Float32(2.0))
    place!(b, Float32(1.0))
    vec3Loc = offset(b)
    #   end vec3

    prependstructslot!(b, 0, vec3Loc, 0) #   vec3. noop
    prependslot!(b, 2, 80, 100)     #   hp
    prependslot!(b, 3, str, 0)
    prependslot!(b, 5, inv, 0) #   inventory
    prependslot!(b, 7, UInt8(1), 0)
    prependslot!(b, 8, mon2, 0)
    prependslot!(b, 9, test4, 0)
    mon = endobject!(b)

    finish!(b, mon)

    return b.bytes, b.head
end

function CheckGetRootAsForNonRootTable()
    b = FlatBuffers.Builder()
    str = createstring!(b, "MyStat")
    Example.StatStart(b)
    Example.StatAddId(b, str)
    Example.StatAddVal(b, 12345678)
    Example.StatAddCount(b, 12345)
    stat_end = Example.StatEnd(b)
    finish!(b, stat_end)

    stat = Example.GetRootAsStat(b.bytes, b.head)

    @test stat.id == "MyStat"
    @test stat.val == 12345678
    @test stat.count == 12345
end

#   CheckGeneratedBuild uses generated code to build the example Monster.
function CheckGeneratedBuild()
    #TODO
    b = FlatBuffers.Builder()
    str = createstring!(b, "MyMonster")
    test1 = createstring!(b, "test1")
    test2 = createstring!(b, "test2")
    fred = createstring!(b, "Fred")

    Example.MonsterStartInventoryVector(b, 5)
    prepend!(b, UInt8(4))
    prepend!(b, UInt8(3))
    prepend!(b, UInt8(2))
    prepend!(b, UInt8(1))
    prepend!(b, UInt8(0))
    inv = endvector!(b, 5)

    Example.MonsterStart(b)
    Example.MonsterAddName(b, fred)
    mon2 = Example.MonsterEnd(b)

    Example.MonsterStartTest4Vector(b, 2)
    Example.CreateTest(b, 10, 20)
    Example.CreateTest(b, 30, 40)
    test4 = endvector!(b, 2)

    Example.MonsterStartTestarrayofstringVector(b, 2)
    prepend!(b, FlatBuffers.UOffsetT(test2))
    prepend!(b, FlatBuffers.UOffsetT(test1))
    testArrayOfString = endvector!(b, 2)

    Example.MonsterStart(b)

    pos = Example.CreateVec3(b, 1.0, 2.0, 3.0, 3.0, Example.ColorGreen, 5, 6)
    Example.MonsterAddPos(b, pos)

    Example.MonsterAddHp(b, 80)
    Example.MonsterAddName(b, str)
    Example.MonsterAddTestbool(b, true)
    Example.MonsterAddInventory(b, inv)
    Example.MonsterAddTestType(b, 1)
    Example.MonsterAddTest(b, mon2)
    Example.MonsterAddTest4(b, test4)
    Example.MonsterAddTestarrayofstring(b, testArrayOfString)
    mon = Example.MonsterEnd(b)

    finish!(b, mon)

    return b.bytes, b.head
end

#   CheckTableAccessors checks that the table accessors work as expected.
function CheckTableAccessors()
    #   test struct accessor
    b = FlatBuffers.Builder()
    pos = Example.CreateVec3(b, 1.0, 2.0, 3.0, 3.0, 4, 5, 6)
    finish!(b, pos)
    vec3Bytes = finishedbytes(b)
    vec3 = Example.Vec3()
    FlatBuffers.GetRootAs(vec3Bytes, 0, vec3)

    @test vec3Bytes == table(vec3).bytes
    
    #   test table accessor
    b = FlatBuffers.Builder()
    str = createstring!(b, "MyStat")
    Example.StatStart(b)
    Example.StatAddId(b, str)
    Example.StatAddVal(b, 12345678)
    Example.StatAddCount(b, 12345)
    pos = Example.StatEnd(b)
    finish!(b, pos)
    statBytes = finishedbytes(b)
    stat = Example.Stat()
    FlatBuffers.GetRootAs(statBytes, 0, stat)

    @test statBytes == table(stat).bytes
end

#   CheckVtableDeduplication verifies that vtables are deduplicated.
function CheckVtableDeduplication()
    b = FlatBuffers.Builder()

    startobject!(b, 4)
    prependslot!(b, 0, UInt8(0), 0)
    prependslot!(b, 1, UInt8(11), 0)
    prependslot!(b, 2, UInt8(22), 0)
    prependslot!(b, 3, Int16(33), 0)
    obj0 = endobject!(b)

    startobject!(b, 4)
    prependslot!(b, 0, UInt8(0), 0)
    prependslot!(b, 1, UInt8(44), 0)
    prependslot!(b, 2, UInt8(55), 0)
    prependslot!(b, 3, Int16(66), 0)
    obj1 = endobject!(b)

    startobject!(b, 4)
    prependslot!(b, 0, UInt8(0), 0)
    prependslot!(b, 1, UInt8(77), 0)
    prependslot!(b, 2, UInt8(88), 0)
    prependslot!(b, 3, Int16(99), 0)
    obj2 = endobject!(b)

    got = b.bytes[b.head:end]

    want = UInt8[
        240, 255, 255, 255, #   == -12. offset to dedupped vtable.
        99, 0,
        88,
        77,
        248, 255, 255, 255, #   == -8. offset to dedupped vtable.
        66, 0,
        55,
        44,
        12, 0,
        8, 0,
        0, 0,
        7, 0,
        6, 0,
        4, 0,
        12, 0, 0, 0,
        33, 0,
        22,
        11,
    ]

    @test want == got
    
    table0 = FlatBuffers.Table(b.bytes, FlatBuffers.UOffsetT(length(b.bytes)) - obj0)
    table1 = FlatBuffers.Table(b.bytes, FlatBuffers.UOffsetT(length(b.bytes)) - obj1)
    table2 = FlatBuffers.Table(b.bytes, FlatBuffers.UOffsetT(length(b.bytes)) - obj2)

    testTable = function(tab, a, b, c, d)
        #   vtable size
        @test got == 
        if got = tab.GetVOffsetTSlot(0, 0); 12 != got
            fail("failed 0, 0: %d", got)
        end
        #   object size
        if got = tab.GetVOffsetTSlot(2, 0); 8 != got
            fail("failed 2, 0: %d", got)
        end
        #   default value
        if got = tab.GetVOffsetTSlot(4, 0); a != got
            fail("failed 4, 0: %d", got)
        end
        if got = tab.GetByteSlot(6, 0); b != got
            fail("failed 6, 0: %d", got)
        end
        if val = tab.GetByteSlot(8, 0); c != val
            fail("failed 8, 0: %d", got)
        end
        if got = tab.GetByteSlot(10, 0); d != got
            fail("failed 10, 0: %d", got)
        end
    end

    testTable(table0, 0, 11, 22, 33)
    testTable(table1, 0, 44, 55, 66)
    testTable(table2, 0, 77, 88, 99)
end

#   CheckNotInObjectError verifies that `EndObject` fails if not inside an
#   object.
function CheckNotInObjectError(fail)
    b = FlatBuffers.Builder()

    defer func()
        r = recover()
        if r == nil
            fail("expected panic in CheckNotInObjectError")
        end
    end()
    endobject!(b)
end

#   CheckStringIsNestedError verifies that a string can not be created inside
#   another object.
function CheckStringIsNestedError(fail)
    b = FlatBuffers.Builder()
    startobject!(b, 0)
    defer func()
        r = recover()
        if r == nil
            fail("expected panic in CheckStringIsNestedError")
        end
    end()
    createstring!(b, "foo")
end

function CheckSharedStrings(fail)
    f = func(strings []string) bool {
        b = FlatBuffers.Builder()
        for _, s1 = range strings {
            for _, s2 = range strings {
                off1 = b.CreateSharedString(s1)
                off2 = b.CreateSharedString(s2)

                if (s1 == s2) && (off1 != off2)
                    return false
                end
                if (s1 != s2) && (off1 == off2)
                    return false
                end
            end
        end
        return true
    end
    if err = quick.Check(f, nil); err != nil
        fail("expected same offset")
    end
end

#   CheckByteStringIsNestedError verifies that a bytestring can not be created
#   inside another object.
function CheckByteStringIsNestedError(fail)
    b = FlatBuffers.Builder()
    startobject!(b, 0)
    defer func()
        r = recover()
        if r == nil
            fail("expected panic in CheckByteStringIsNestedError")
        end
    end()
    createstring!(b, []byte("foo"))
end

#   CheckStructIsNotInlineError verifies that writing a struct in a location
#   away from where it is used will cause a panic.
function CheckStructIsNotInlineError(fail)
    b = FlatBuffers.Builder()
    startobject!(b, 0)
    defer func()
        r = recover()
        if r == nil
            fail("expected panic in CheckStructIsNotInlineError")
        end
    end()
    prependstructslot!(b, 0, 1, 0)
end

#   CheckFinishedBytesError verifies that `FinishedBytes` panics if the table
#   is not finished.
function CheckFinishedBytesError(fail)
    b = FlatBuffers.Builder()

    defer func()
        r = recover()
        if r == nil
            fail("expected panic in CheckFinishedBytesError")
        end
    end()
    finishedbytes(b)
end

#   CheckEnumNames checks that the generated enum names are correct.
function CheckEnumNames(fail)
    {
        want = map[Example.Any]string{
            Example.AnyNONE:                    "NONE",
            Example.AnyMonster:                 "Monster",
            Example.AnyTestSimpleTableWithEnum: "TestSimpleTableWithEnum",
            Example.AnyMyGame_Example2_Monster: "MyGame_Example2_Monster",
        end
        got = Example.EnumNamesAny
        if !reflect.DeepEqual(got, want)
            fail("enum name is not equal")
        end
    end
    {
        want = map[Example.Color]string{
            Example.ColorRed:   "Red",
            Example.ColorGreen: "Green",
            Example.ColorBlue:  "Blue",
        end
        got = Example.EnumNamesColor
        if !reflect.DeepEqual(got, want)
            fail("enum name is not equal")
        end
    end
end

#   CheckEnumString checks the String method on generated enum types.
function CheckEnumString(fail)
    if got = Example.AnyMonster.String(); got != "Monster"
        fail("Monster.String: %q != %q", got, "Monster")
    end
    if got = fmt.Sprintf("color: %s", Example.ColorGreen); got != "color: Green"
        fail("color.String: %q != %q", got, "color: Green")
    end
end

#   CheckEnumValues checks that the generated enum values maps are correct.
function CheckEnumValues(fail)
    {
        want = map[string]Example.Any{
            "NONE":                    Example.AnyNONE,
            "Monster":                 Example.AnyMonster,
            "TestSimpleTableWithEnum": Example.AnyTestSimpleTableWithEnum,
            "MyGame_Example2_Monster": Example.AnyMyGame_Example2_Monster,
        end
        got = Example.EnumValuesAny
        if !reflect.DeepEqual(got, want)
            fail("enum name is not equal")
        end
    end
    {
        want = map[string]Example.Color{
            "Red":   Example.ColorRed,
            "Green": Example.ColorGreen,
            "Blue":  Example.ColorBlue,
        end
        got = Example.EnumValuesColor
        if !reflect.DeepEqual(got, want)
            fail("enum name is not equal")
        end
    end
end

#   CheckDocExample checks that the code given in FlatBuffers documentation
#   is syntactically correct.
function CheckDocExample(buf, off)
    monster = Example.GetRootAsMonster(buf, off)
    _ = monster.Hp()
    _ = monster.Pos(nil)
    for i = 0; i < monster.InventoryLength(); i++ {
        _ = monster.Inventory(i) #   do something here
    end

    builder = FlatBuffers.Builder()

    Example.MonsterStartInventoryVector(builder, 5)
    for i = 4; i >= 0; i-- {
        prepend!(b, UInt8(byte)(i))
    end
    inv = builder.EndVector(5)

    str = builder.CreateString("MyMonster")
    Example.MonsterStart(builder)
    Example.MonsterAddPos(builder, Example.CreateVec3(builder, 1.0, 2.0, 3.0, 3.0, Example.Color(4), 5, 6))
    Example.MonsterAddHp(builder, 80)
    Example.MonsterAddName(builder, str)
    Example.MonsterAddInventory(builder, inv)
    Example.MonsterAddTestType(builder, 1)
    Example.MonsterAddColor(builder, Example.ColorRed)
    #   Example.MonsterAddTest(builder, mon2)
    #   Example.MonsterAddTest4(builder, test4s)
    _ = Example.MonsterEnd(builder)
end

function CheckCreateByteVector(fail)
    raw = [30]byte{end
    for i = 0; i < len(raw); i++ {
        raw[i] = byte(i)
    end

    for size = 0; size < len(raw); size++ {
        b1 = FlatBuffers.Builder()
        b2 = FlatBuffers.Builder()
        b1.startvector!(1, size, 1)
        for i = size - 1; i >= 0; i-- {
            prepend!(b, UInt8(raw)[i])
        end
        b1.EndVector(size)
        b2.CreateByteVector(raw[:size])
        CheckByteEquality(b1.Bytes, b2.Bytes)
    end
end

function CheckParentNamespace(fail)
    var empty, nonempty []byte

    #   create monster with an empty parent namespace field
    {
        builder = FlatBuffers.Builder()

        Example.MonsterStart(builder)
        m = Example.MonsterEnd(builder)
        finish!(builder, m)

        empty = make([]byte, len(finishedbytes(builder)))
        copy(empty, finishedbytes(builder))
    end

    #   create monster with a non-empty parent namespace field
    {
        builder = FlatBuffers.Builder()
        mygame.InParentNamespaceStart(builder)
        pn = mygame.InParentNamespaceEnd(builder)

        Example.MonsterStart(builder)
        Example.MonsterAddParentNamespaceTest(builder, pn)
        m = Example.MonsterEnd(builder)

        finish!(builder, m)

        nonempty = make([]byte, len(finishedbytes(builder)))
        copy(nonempty, finishedbytes(builder))
    end

    #   read monster with empty parent namespace field
    {
        m = Example.GetRootAsMonster(empty, 0)
        if m.ParentNamespaceTest(nil) != nil
            fail("expected nil ParentNamespaceTest for empty field")
        end
    end

    #   read monster with non-empty parent namespace field
    {
        m = Example.GetRootAsMonster(nonempty, 0)
        if m.ParentNamespaceTest(nil) == nil
            fail("expected non-nil ParentNamespaceTest for non-empty field")
        end
    end
end

#   Include simple random number generator to ensure results will be the
#   same cross platform.
#   http://en.wikipedia.org/wiki/Park%E2%80%93Miller_random_number_generator
type LCG UInt32

const InitialLCGSeed = 48271

function NewLCG() *LCG {
    n = UInt32(InitialLCGSeed)
    l = LCG(n)
    return &l
end

function (lcg *LCG) Reset()
    *lcg = InitialLCGSeed
end

function (lcg *LCG) Next() UInt32 {
    n = UInt32((uint64(*lcg) * uint64(279470273)) % uint64(4294967291))
    *lcg = LCG(n)
    return n
end

#   CheckByteEquality verifies that two byte buffers are the same.
function CheckByteEquality(a, b)
    if !bytes.Equal(a, b)
        fail("objects are not byte-wise equal")
    end
end

#   CheckMutateMethods checks all mutate methods one by one
function CheckMutateMethods(fail)
    b = FlatBuffers.Builder()
    startobject!(b, 15)
    prependslot!(b, 0, true, false)
    prependslot!(b, 1, UInt8(1), 0)
    prependslot!(b, 2, 2, 0)
    prependslot!(b, 3, 3, 0)
    prependslot!(b, 4, 4, 0)
    prependslot!(b, 5, 5, 0)
    prependslot!(b, 6, 6, 0)
    prependslot!(b, 7, 7, 0)
    prependslot!(b, 8, 8, 0)
    prependslot!(b, 9, 9, 0)
    prependslot!(b, 10, 10, 0)
    prependslot!(b, 11, 11, 0)

    prependslot!(b, 12, 12, 0)
    uoVal = offset(b) - 12

    b.PrependVOffsetT(13)
    b.Slot(13)

    b.PrependSOffsetT(14)
    b.Slot(14)
    soVal = FlatBuffers.SOffsetT(offset(b) - 14)

    offset = endobject!(b)

    t = FlatBuffers.Table(
        Bytes: b.bytes,
        Pos:   FlatBuffers.UOffsetT(len(b.bytes)) - offset,
    end

    calcVOffsetT = func(slot int) (vtableOffset FlatBuffers.VOffsetT)
        return FlatBuffers.VOffsetT((FlatBuffers.VtableMetadataFields + slot) * FlatBuffers.SizeVOffsetT)
    end
    calcUOffsetT = func(vtableOffset FlatBuffers.VOffsetT) (valueOffset FlatBuffers.UOffsetT)
        return t.Pos + FlatBuffers.UOffsetT(t.Offset(vtableOffset))
    end

    type testcase struct {
        field  string
        testfn func() bool
    end

    testForOriginalValues = []testcase{
        testcase{"BoolSlot", func() bool { return t.getslot(calcVOffsetT(0), true) == true }end,
        testcase{"ByteSlot", func() bool { return t.GetByteSlot(calcVOffsetT(1), 1) == 1 }end,
        testcase{"Uint8Slot", func() bool { return t.getslot(calcVOffsetT(2), 2) == 2 }end,
        testcase{"Uint16Slot", func() bool { return t.getslot(calcVOffsetT(3), 3) == 3 }end,
        testcase{"Uint32Slot", func() bool { return t.getslot(calcVOffsetT(4), 4) == 4 }end,
        testcase{"Uint64Slot", func() bool { return t.getslot(calcVOffsetT(5), 5) == 5 }end,
        testcase{"Int8Slot", func() bool { return t.getslot(calcVOffsetT(6), 6) == 6 }end,
        testcase{"Int16Slot", func() bool { return t.getslot(calcVOffsetT(7), 7) == 7 }end,
        testcase{"Int32Slot", func() bool { return t.getslot(calcVOffsetT(8), 8) == 8 }end,
        testcase{"Int64Slot", func() bool { return t.getslot(calcVOffsetT(9), 9) == 9 }end,
        testcase{"Float32Slot", func() bool { return t.getslot(calcVOffsetT(10), 10) == 10 }end,
        testcase{"Float64Slot", func() bool { return t.getslot(calcVOffsetT(11), 11) == 11 }end,
        testcase{"UOffsetTSlot", func() bool { return t.GetUOffsetT(calcUOffsetT(calcVOffsetT(12))) == uoVal }end,
        testcase{"VOffsetTSlot", func() bool { return t.GetVOffsetT(calcUOffsetT(calcVOffsetT(13))) == 13 }end,
        testcase{"SOffsetTSlot", func() bool { return t.GetSOffsetT(calcUOffsetT(calcVOffsetT(14))) == soVal }end,
    end

    testMutability = []testcase{
        testcase{"BoolSlot", func() bool { return t.MutateBoolSlot(calcVOffsetT(0), false) }end,
        testcase{"ByteSlot", func() bool { return t.MutateByteSlot(calcVOffsetT(1), 2) }end,
        testcase{"Uint8Slot", func() bool { return t.MutateUint8Slot(calcVOffsetT(2), 4) }end,
        testcase{"Uint16Slot", func() bool { return t.MutateUint16Slot(calcVOffsetT(3), 6) }end,
        testcase{"Uint32Slot", func() bool { return t.MutateUint32Slot(calcVOffsetT(4), 8) }end,
        testcase{"Uint64Slot", func() bool { return t.MutateUint64Slot(calcVOffsetT(5), 10) }end,
        testcase{"Int8Slot", func() bool { return t.MutateInt8Slot(calcVOffsetT(6), 12) }end,
        testcase{"Int16Slot", func() bool { return t.MutateInt16Slot(calcVOffsetT(7), 14) }end,
        testcase{"Int32Slot", func() bool { return t.MutateInt32Slot(calcVOffsetT(8), 16) }end,
        testcase{"Int64Slot", func() bool { return t.MutateInt64Slot(calcVOffsetT(9), 18) }end,
        testcase{"Float32Slot", func() bool { return t.MutateFloat32Slot(calcVOffsetT(10), 20) }end,
        testcase{"Float64Slot", func() bool { return t.MutateFloat64Slot(calcVOffsetT(11), 22) }end,
        testcase{"UOffsetTSlot", func() bool { return t.MutateUOffsetT(calcUOffsetT(calcVOffsetT(12)), 24) }end,
        testcase{"VOffsetTSlot", func() bool { return t.MutateVOffsetT(calcUOffsetT(calcVOffsetT(13)), 26) }end,
        testcase{"SOffsetTSlot", func() bool { return t.MutateSOffsetT(calcUOffsetT(calcVOffsetT(14)), 28) }end,
    end

    testMutabilityWithoutSlot = []testcase{
        testcase{"BoolSlot", func() bool { return t.MutateBoolSlot(calcVOffsetT(16), false) }end,
        testcase{"ByteSlot", func() bool { return t.MutateByteSlot(calcVOffsetT(16), 2) }end,
        testcase{"Uint8Slot", func() bool { return t.MutateUint8Slot(calcVOffsetT(16), 2) }end,
        testcase{"Uint16Slot", func() bool { return t.MutateUint16Slot(calcVOffsetT(16), 2) }end,
        testcase{"Uint32Slot", func() bool { return t.MutateUint32Slot(calcVOffsetT(16), 2) }end,
        testcase{"Uint64Slot", func() bool { return t.MutateUint64Slot(calcVOffsetT(16), 2) }end,
        testcase{"Int8Slot", func() bool { return t.MutateInt8Slot(calcVOffsetT(16), 2) }end,
        testcase{"Int16Slot", func() bool { return t.MutateInt16Slot(calcVOffsetT(16), 2) }end,
        testcase{"Int32Slot", func() bool { return t.MutateInt32Slot(calcVOffsetT(16), 2) }end,
        testcase{"Int64Slot", func() bool { return t.MutateInt64Slot(calcVOffsetT(16), 2) }end,
        testcase{"Float32Slot", func() bool { return t.MutateFloat32Slot(calcVOffsetT(16), 2) }end,
        testcase{"Float64Slot", func() bool { return t.MutateFloat64Slot(calcVOffsetT(16), 2) }end,
    end

    testForMutatedValues = []testcase{
        testcase{"BoolSlot", func() bool { return t.getslot(calcVOffsetT(0), true) == false }end,
        testcase{"ByteSlot", func() bool { return t.GetByteSlot(calcVOffsetT(1), 1) == 2 }end,
        testcase{"Uint8Slot", func() bool { return t.getslot(calcVOffsetT(2), 1) == 4 }end,
        testcase{"Uint16Slot", func() bool { return t.getslot(calcVOffsetT(3), 1) == 6 }end,
        testcase{"Uint32Slot", func() bool { return t.getslot(calcVOffsetT(4), 1) == 8 }end,
        testcase{"Uint64Slot", func() bool { return t.getslot(calcVOffsetT(5), 1) == 10 }end,
        testcase{"Int8Slot", func() bool { return t.getslot(calcVOffsetT(6), 1) == 12 }end,
        testcase{"Int16Slot", func() bool { return t.getslot(calcVOffsetT(7), 1) == 14 }end,
        testcase{"Int32Slot", func() bool { return t.getslot(calcVOffsetT(8), 1) == 16 }end,
        testcase{"Int64Slot", func() bool { return t.getslot(calcVOffsetT(9), 1) == 18 }end,
        testcase{"Float32Slot", func() bool { return t.getslot(calcVOffsetT(10), 1) == 20 }end,
        testcase{"Float64Slot", func() bool { return t.getslot(calcVOffsetT(11), 1) == 22 }end,
        testcase{"UOffsetTSlot", func() bool { return t.GetUOffsetT(calcUOffsetT(calcVOffsetT(12))) == 24 }end,
        testcase{"VOffsetTSlot", func() bool { return t.GetVOffsetT(calcUOffsetT(calcVOffsetT(13))) == 26 }end,
        testcase{"SOffsetTSlot", func() bool { return t.GetSOffsetT(calcUOffsetT(calcVOffsetT(14))) == 28 }end,
    end

    #   make sure original values are okay
    for _, t = range testForOriginalValues {
        if !t.testfn()
            fail(t.field + "' field doesn't have the expected original value")
        end
    end

    #   try to mutate fields and check mutability
    for _, t = range testMutability {
        if !t.testfn()
            error(string(t.field+"' field failed mutability test", "passed", "failed"))
        end
    end

    #   try to mutate fields and check mutability
    #   these have wrong slots so should fail
    for _, t = range testMutabilityWithoutSlot {
        if t.testfn()
            error(string(t.field+"' field failed no slot mutability test", "failed", "passed"))
        end
    end

    #   test whether values have changed
    for _, t = range testForMutatedValues {
        if !t.testfn()
            fail(t.field + "' field doesn't have the expected mutated value")
        end
    end
end

#   BenchmarkVtableDeduplication measures the speed of vtable deduplication
#   by creating prePop vtables, then populating b.N objects with a
#   different single vtable.
//
#   When b.N is large (as in long benchmarks), memory usage may be high.
function BenchmarkVtableDeduplication(b *testing.B)
    prePop = 10
    builder = FlatBuffers.Builder()

    #   pre-populate some vtables:
    for i = 0; i < prePop; i++ {
        builder.startobject!(i)
        for j = 0; j < i; j++ {
            prependslot!(builder, j, int16(j), 0)
        end
        builder.EndObject()
    end

    #   benchmark deduplication of a new vtable:
    b.ResetTimer()
    for i = 0; i < b.N; i++ {
        lim = prePop

        builder.startobject!(lim)
        for j = 0; j < lim; j++ {
            prependslot!(builder, j, int16(j), 0)
        end
        builder.EndObject()
    end
end

#   BenchmarkParseGold measures the speed of parsing the 'gold' data
#   used throughout this test suite.
function BenchmarkParseGold(b *testing.B)
    buf, offset = CheckGeneratedBuild(b.Fatalf)
    monster = Example.GetRootAsMonster(buf, offset)

    #   use these to prevent allocations:
    reuse_pos = Example.Vec3{end
    reuse_test3 = Example.Test{end
    reuse_table2 = FlatBuffers.Table{end
    reuse_monster2 = Example.Monster{end
    reuse_test4_0 = Example.Test{end
    reuse_test4_1 = Example.Test{end

    b.SetBytes(int64(len(buf[offset:])))
    b.ReportAllocs()
    b.ResetTimer()
    for i = 0; i < b.N; i++ {
        monster.Hp()
        monster.Mana()
        name = monster.Name()
        _ = name[0]
        _ = name[len(name)-1]

        monster.Pos(&reuse_pos)
        reuse_pos.X()
        reuse_pos.Y()
        reuse_pos.Z()
        reuse_pos.Test1()
        reuse_pos.Test2()
        reuse_pos.Test3(&reuse_test3)
        reuse_test3.A()
        reuse_test3.B()
        monster.TestType()
        monster.Test(&reuse_table2)
        reuse_monster2.Init(reuse_table2.Bytes, reuse_table2.Pos)
        name2 = reuse_monster2.Name()
        _ = name2[0]
        _ = name2[len(name2)-1]
        monster.InventoryLength()
        l = monster.InventoryLength()
        for i = 0; i < l; i++ {
            monster.Inventory(i)
        end
        monster.Test4Length()
        monster.Test4(&reuse_test4_0, 0)
        monster.Test4(&reuse_test4_1, 1)

        reuse_test4_0.A()
        reuse_test4_0.B()
        reuse_test4_1.A()
        reuse_test4_1.B()

        monster.TestarrayofstringLength()
        str0 = monster.Testarrayofstring(0)
        _ = str0[0]
        _ = str0[len(str0)-1]
        str1 = monster.Testarrayofstring(1)
        _ = str1[0]
        _ = str1[len(str1)-1]
    end
end

#   BenchmarkBuildGold uses generated code to build the example Monster.
function BenchmarkBuildGold(b *testing.B)
    buf, offset = CheckGeneratedBuild(b.Fatalf)
    bytes_length = int64(len(buf[offset:]))

    reuse_str = "MyMonster"
    reuse_test1 = "test1"
    reuse_test2 = "test2"
    reuse_fred = "Fred"

    b.SetBytes(bytes_length)
    bldr = FlatBuffers.Builder()
    b.ResetTimer()
    b.ReportAllocs()
    for i = 0; i < b.N; i++ {
        bldr.Reset()

        str = bldr.CreateString(reuse_str)
        test1 = bldr.CreateString(reuse_test1)
        test2 = bldr.CreateString(reuse_test2)
        fred = bldr.CreateString(reuse_fred)

        Example.MonsterStartInventoryVector(bldr, 5)
        prepend!(b, UInt8(4))
        prepend!(b, UInt8(3))
        prepend!(b, UInt8(2))
        prepend!(b, UInt8(1))
        prepend!(b, UInt8(0))
        inv = bldr.EndVector(5)

        Example.MonsterStart(bldr)
        Example.MonsterAddName(bldr, fred)
        mon2 = Example.MonsterEnd(bldr)

        Example.MonsterStartTest4Vector(bldr, 2)
        Example.CreateTest(bldr, 10, 20)
        Example.CreateTest(bldr, 30, 40)
        test4 = bldr.EndVector(2)

        Example.MonsterStartTestarrayofstringVector(bldr, 2)
        bldr.PrependUOffsetT(test2)
        bldr.PrependUOffsetT(test1)
        testArrayOfString = bldr.EndVector(2)

        Example.MonsterStart(bldr)

        pos = Example.CreateVec3(bldr, 1.0, 2.0, 3.0, 3.0, Example.ColorGreen, 5, 6)
        Example.MonsterAddPos(bldr, pos)

        Example.MonsterAddHp(bldr, 80)
        Example.MonsterAddName(bldr, str)
        Example.MonsterAddInventory(bldr, inv)
        Example.MonsterAddTestType(bldr, 1)
        Example.MonsterAddTest(bldr, mon2)
        Example.MonsterAddTest4(bldr, test4)
        Example.MonsterAddTestarrayofstring(bldr, testArrayOfString)
        mon = Example.MonsterEnd(bldr)

        finish!(bldr, mon)
    end
end

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example2

import FlatBuffers

mutable struct Monster
end
FlatBuffers.@ALIGN(Monster, 1)

Monster(buf::AbstractVector{UInt8}) = FlatBuffers.read(Monster, buf)
Monster(io::IO) = FlatBuffers.deserialize(io, Monster)

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@STRUCT struct Ability
    id::UInt32
    distance::UInt32
end
FlatBuffers.@ALIGN(Ability, 4)

Ability(buf::AbstractVector{UInt8}) = FlatBuffers.read(Ability, buf)
Ability(io::IO) = FlatBuffers.deserialize(io, Ability)

using FlatBuffers
using Test

include("defaults.jl")
include("internals.jl")
CheckByteLayout()
CheckManualBuild()
CheckVtableDeduplication()
CheckNotInObjectError()
CheckStringIsNestedError()
CheckByteStringIsNestedError()
CheckStructIsNotInlineError()
CheckFinishedBytesError()
CheckCreateByteVector()
checkFuzz(100, 100, true)

include("flatc.jl")

include("monster.jl")

vec3 = SmallExample.Vec3(1.0, 2.0, 3.0, 3.0, SmallExample.Color(1), SmallExample.Test(5, 6))
test4 = SmallExample.Test[SmallExample.Test(10, 20), SmallExample.Test(30, 40)]
testArrayOfString = ["test1","test2"]

mon = SmallExample.Monster(vec3, 150, 80, "MyMonster", false, collect(0x00:0x04),
	SmallExample.Blue, test4, testArrayOfString, SmallExample.Monster[],
	UInt8[], SmallExample.Stat("",0,0), false, 0, 0, 0, 0, 0, 0, 0, 0,
	Bool[], 0, 0, 0)
b = FlatBuffers.build!(mon)
monst = FlatBuffers.read(b)
monst2 = FlatBuffers.read(SmallExample.Monster, FlatBuffers.bytes(b))

@test mon.pos == monst.pos
@test mon.pos == monst2.pos

# create test types
# types (Scalar, Enum, struct, T, String, Vector{UInt8})
mutable struct TestInt8T
	x::Int8
end

inst1 = TestInt8T(1)

b = FlatBuffers.Builder(TestInt8T)
FlatBuffers.build!(b, inst1)
t = FlatBuffers.Table(b)
inst1_2 = FlatBuffers.read(t)

@test inst1.x === inst1_2.x

struct TestInt8I
	x::Int8
end

inst2 = TestInt8I(2)

mutable struct TestInt8A
	x::Union{Nothing, Vector{Int8}}
end

inst3 = TestInt8A([1,2,3])

b = FlatBuffers.Builder(TestInt8A)
FlatBuffers.build!(b, inst3)
t = FlatBuffers.Table(b)
inst3_2 = FlatBuffers.read(t)

@test inst3.x == inst3_2.x

mutable struct TestMixT
	x::Int8
	y::String
	z::Union{Nothing, Vector{Int8}}
end

inst4 = TestMixT(10,"singin tooralli ooralli addity",[1,2,3])

b = FlatBuffers.Builder(TestMixT)
FlatBuffers.build!(b, inst4)
t = FlatBuffers.Table(b)
inst4_2 = FlatBuffers.read(t)

@test inst4.x == inst4_2.x && inst4.y == inst4_2.y && inst4.z == inst4_2.z

# simple sub-table/type (Stat)
mutable struct TestSubT
	x::TestInt8T
	y::TestInt8I
	z::TestInt8A
end

inst5 = TestSubT(inst1, inst2, inst3)

b = FlatBuffers.Builder(TestSubT)
FlatBuffers.build!(b, inst5)
t = FlatBuffers.Table(b)
inst5_2 = FlatBuffers.read(t)

@test inst5.x.x == inst5_2.x.x && inst5.y.x == inst5_2.y.x && inst5.z.x == inst5_2.z.x

# vtable duplicates
mutable struct TestDupT
	x::TestInt8T
	y::TestInt8I
	z::TestInt8T
end

inst6 = TestDupT(inst1, inst2, TestInt8T(2))

b = FlatBuffers.Builder(TestDupT)
FlatBuffers.build!(b, inst6)
t = FlatBuffers.Table(b)
inst6_2 = FlatBuffers.read(t)

@test inst6.x.x == inst6_2.x.x && inst6.y.x == inst6_2.y.x && inst6.z.x == inst6_2.z.x

mutable struct TestDup2T
	x::Vector{TestInt8T}
end

inst7 = TestDup2T([inst1, TestInt8T(2), TestInt8T(3), TestInt8T(4)])

b = FlatBuffers.Builder(TestDup2T)
FlatBuffers.build!(b, inst7)
t = FlatBuffers.Table(b)
inst7_2 = FlatBuffers.read(t)

@test all(map(x->x.x, inst7.x) .== map(x->x.x, inst7_2.x))

# self-referential type test (type has subtype of itself)
# type TestCircT
#     x::Int8
#     y::TestCircT
# end
#
# struct TestCircI
#     x::Int8
#     y::TestCircI
# end

# simple Union (Any_)

# fbs
# table TestUnionT {
#     x::TestUnionI
# }

@UNION TestUnionU (Nothing,TestInt8T,TestInt8A)

mutable struct TestUnionT
	x_type::Int8
	x::TestUnionU
end

TestUnionT(x::TestUnionU) = TestUnionT(FlatBuffers.typeorder(TestUnionU, typeof(x)), x)

inst8 = TestUnionT(inst1)

b = FlatBuffers.Builder(TestUnionT)
FlatBuffers.build!(b, inst8)
t = FlatBuffers.Table(b)
inst8_2 = FlatBuffers.read(t)

@test inst8.x_type == inst8_2.x_type && inst8.x.x == inst8_2.x.x

inst9 = TestUnionT(inst3)

b = FlatBuffers.Builder(TestUnionT)
FlatBuffers.build!(b, inst9)
t = FlatBuffers.Table(b)
inst9_2 = FlatBuffers.read(t)

@test inst9.x_type == inst9_2.x_type && inst9.x.x == inst9_2.x.x

const Nachos = String
const Burgers = Int
FlatBuffers.@UNION(Delicious,
	(Burgers, Nachos)
)

FlatBuffers.@with_kw mutable struct TestVecUnionT
	xs_type::Vector{UInt8}
	xs::Vector{TestUnionU}
	ys_type::Vector{UInt8}
	ys::Vector{Delicious}
end

function TestVecUnionT(xs::Vector{A}, ys::Vector{B}) where {A<:TestUnionU, B<:Delicious}
	xs_type = [FlatBuffers.typeorder(TestUnionU, typeof(x)) for x in xs]
	ys_type = [FlatBuffers.typeorder(Delicious, typeof(y)) for y in ys]
	TestVecUnionT(xs_type, xs, ys_type, ys)
end

dinner = "beef"
inst10 = TestVecUnionT(TestUnionU[inst1, inst1, inst1], [dinner])

b = FlatBuffers.Builder(TestVecUnionT)
FlatBuffers.build!(b, inst10)

t = FlatBuffers.Table(b)
inst10_2 = FlatBuffers.read(t)

@test inst10.xs_type == inst10_2.xs_type
@test [x.x for x in inst10.xs] == [x.x for x in inst10_2.xs]

inst11 = TestVecUnionT(TestUnionU[inst3, inst3], [dinner for _ = 1:9])

b = FlatBuffers.Builder(TestVecUnionT)
FlatBuffers.build!(b, inst11)
t = FlatBuffers.Table(b)
inst11_2 = FlatBuffers.read(t)

@test inst11.xs_type == inst11_2.xs_type
@test [x.x for x in inst11.xs] == [x.x for x in inst11_2.xs]
@test inst11.ys_type == inst11_2.ys_type
@test [y for y in inst11.ys] == [y for y in inst11_2.ys]

# test @STRUCT macro
@STRUCT struct A
	a::Int32
end
@test sizeof(A) == 4
@test all(fieldnames(A) .== [:a])
@test A(1) == A(1)

@STRUCT struct B
	a::Int8
	b::Int32
end
@test sizeof(B) == 8
@test all(fieldnames(B) .== [:a, :_pad_a_B_0, :_pad_a_B_1, :b])
@test B(1,2) == B(1,2)

@STRUCT struct C
	a::Int16
	b::Int32
	c::Int16
end
@test sizeof(C) == 12
@test all(fieldnames(C) .== [:a, :_pad_a_C_0, :b, :c, :_pad_c_C_1])
@test C(1,2,3) == C(1,2,3)

@STRUCT struct D
	a::Int8
	b::Int64
end
@test sizeof(D) == 16
@test all(fieldnames(D) .== [:a, :_pad_a_D_0, :_pad_a_D_1, :_pad_a_D_2, :b])
@test D(1,2) == D(1,2)

@STRUCT struct E
	a::Int64
	b::Int32
end
@test sizeof(E) == 16
@test all(fieldnames(E) .== [:a, :b, :_pad_b_E_0])
@test E(1,2) == E(1,2)

@STRUCT struct F
	a::Int32
	b::Int16
	c::Int32
	d::Int32
	e::Int64
end
@test sizeof(F) == 24
@test all(fieldnames(F) .== [:a, :b, :_pad_b_F_0, :c, :d, :e])
@test F(1,2,3,4,5) == F(1,2,3,4,5)

@STRUCT struct G
	a::Float64
	b::Int8
	c::Int16
	d::Int32
end
@test sizeof(G) == 24
@test all(fieldnames(G) .== [:a, :b, :_pad_b_G_0, :c, :_pad_c_G_1, :d])
@test G(1,2,3,4) == G(1,2,3,4)

@STRUCT struct H
	a::Float32
	b::Int8
	c::Int16
end
@test sizeof(H) == 8
@test all(fieldnames(H) .== [:a, :b, :_pad_b_H_0, :c])
@test H(1,2,3) == H(1,2,3)

@STRUCT struct I
	a::Float64
	b::Int8
	c::Int32
end
@test sizeof(I) == 16
@test all(fieldnames(I) .== [:a, :b, :_pad_b_I_0, :_pad_b_I_1, :c])
@test I(1,2,3) == I(1,2,3)

@STRUCT struct J
	a::Int8
	b::A
end
@test sizeof(J) == 8
@test all(fieldnames(J) .== [:a, :_pad_a_J_0, :_pad_a_J_1, :b_a])
@test J(1,A(2)) == J(1,A(2))

@STRUCT struct K
	a::J
	b::I
	c::J
end
@test sizeof(K) == 48
@test all(fieldnames(K) .== [:a_a, :a__pad_a_J_0, :a__pad__pad_a_J_0_J_0, :a__pad_a_J_1, :a__pad__pad_a_J_1_J_1, :a_b_a, :b_a, :b_b, :b__pad_b_I_0, :b__pad__pad_b_I_0_I_0, :b__pad_b_I_1, :b__pad__pad_b_I_1_I_1, :b_c, :c_a, :c__pad_a_J_0, :c__pad__pad_a_J_0_J_0, :c__pad_a_J_1, :c__pad__pad_a_J_1_J_1, :c_b_a])
@test K(J(1,A(2)), I(3.0, 4, 5), J(6, A(7))) == K(J(1,A(2)), I(3.0, 4, 5), J(6, A(7)))

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@with_kw mutable struct TestSimpleTableWithEnum
    color::Color = 2
end
FlatBuffers.@ALIGN(TestSimpleTableWithEnum, 1)
FlatBuffers.slot_offsets(::Type{T}) where {T<:TestSimpleTableWithEnum} = [
    0x00000004
]

TestSimpleTableWithEnum(buf::AbstractVector{UInt8}) = FlatBuffers.read(TestSimpleTableWithEnum, buf)
TestSimpleTableWithEnum(io::IO) = FlatBuffers.deserialize(io, TestSimpleTableWithEnum)

using Test
import FlatBuffers

# generated code
include("MyGame/MyGame.jl")
import .MyGame
import .MyGame.Example
import .MyGame.Example2
import .MyGame.Example.Any_
import .MyGame.Example.Monster
import .MyGame.Example.TestSimpleTableWithEnum

# override the typeorder function, since we are working around
# circular type definitions using type parameters
FlatBuffers.typeorder(::Type{Any_}, i::Integer) = [Nothing, Monster{Any_}, TestSimpleTableWithEnum, Example2.Monster][i+1]

function loadmonsterfile(filename)
    open(joinpath(@__DIR__, filename), "r") do f Monster{Any_}(f) end
end

function checkmonster(monster)
    @test monster.hp == 80
    @test monster.mana == 150
    @test monster.name == "MyMonster"

    vec = monster.pos

    @test vec.x == 1.0
    @test vec.y == 2.0
    @test vec.z == 3.0
    @test vec.test1 == 3.0
    @test vec.test2 == MyGame.Example.ColorGreen
    @test vec.test3_a == 5
    @test vec.test3_b == 6

    monster2 = monster.test
    @test monster2.name == "Fred"

    @test length(monster.inventory) == 5
    @test sum(monster.inventory) == 10

    @test monster.vector_of_longs == [10 ^ (2*i) for i = 0:4]
    @test monster.vector_of_doubles == [-1.7976931348623157e+308, 0, 1.7976931348623157e+308]

    @test length(monster.test4) == 2

    (test0, test1) = monster.test4
    @test sum([test0.a, test0.b, test1.a, test1.b]) == 100

    @test monster.testarrayofstring == ["test1", "test2"]
    @test monster.testarrayoftables == []
    @test monster.testf == 3.14159f0
end

function checkpassthrough(monster)
    b = FlatBuffers.Builder(Monster{Any_})
    FlatBuffers.build!(b, monster)
    bytes = FlatBuffers.bytes(b)
    @test FlatBuffers.has_identifier(Monster{Any_}, bytes)
    newmonster = FlatBuffers.read(Monster{Any_}, bytes)
    checkmonster(newmonster)
end

function checkserialize(monster)
    io = IOBuffer()
    FlatBuffers.serialize(io, monster)
    bytes = take!(io)
    newmonster = FlatBuffers.deserialize(IOBuffer(bytes), Monster{Any_})
    checkmonster(newmonster)
end

@test FlatBuffers.root_type(Monster) == true
@test FlatBuffers.file_identifier(Monster) == "MONS"
@test FlatBuffers.file_extension(Monster) == "mon"

for testcase in ["test", "python_wire"]
    mon = loadmonsterfile("monsterdata_$testcase.mon")
    checkmonster(mon)
    checkpassthrough(mon)
    checkserialize(mon)
end

# test printing
mon = loadmonsterfile("monsterdata_test.mon")
b = FlatBuffers.Builder(Monster{Any_})
FlatBuffers.build!(b, mon)
io = IOBuffer()
show(io, b)
output = String(take!(io))
@test occursin("deprecated field", split(output, "\n")[9])

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@STRUCT struct Test
    a::Int16
    b::Int8
end
FlatBuffers.@ALIGN(Test, 2)

Test(buf::AbstractVector{UInt8}) = FlatBuffers.read(Test, buf)
Test(io::IO) = FlatBuffers.deserialize(io, Test)

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@UNION(AnyAmbiguousAliases, (
    Nothing,
    Monster,
    Monster,
    Monster,
))

using FlatBuffers
using Test
import Parameters

# test default fields
@with_kw mutable struct UltimateAnswer
    answer::Int32 = 42
    question::String
    highwaysbuilt::Int32 = 7
end

x = UltimateAnswer(;question="How many roads must a man walk down?")
@test x.answer == 42
@test FlatBuffers.default(UltimateAnswer, Int32, :answer) == 42
@test FlatBuffers.default(UltimateAnswer, Int32, :highwaysbuilt) == 7
b = FlatBuffers.Builder(UltimateAnswer)
FlatBuffers.build!(b, x)
xbytes = FlatBuffers.bytes(b)
y = FlatBuffers.read(UltimateAnswer, xbytes)

@test y.answer == x.answer
@test y.question == x.question
@test y.highwaysbuilt == x.highwaysbuilt
@test x.highwaysbuilt == 7

y = Parameters.reconstruct(x, highwaysbuilt = 0)
b = FlatBuffers.Builder(UltimateAnswer)
FlatBuffers.build!(b, y)
ybytes = FlatBuffers.bytes(b)

# check that we save bytes with default integer values
@test length(ybytes) > length(xbytes)

@test y.answer == x.answer
@test y.question == x.question
@test y.highwaysbuilt == 0

y = FlatBuffers.read(UltimateAnswer, ybytes)
@test y.highwaysbuilt == 0

module FlatBuffers

# utils
"""
serialize(stream::IO, value::T) where {T}
Serialize `value` to `stream` using the `FlatBuffer` format.
"""
function serialize(stream::IO, value::T) where {T}
	write(stream, bytes(build!(value)))
end

"""
deserialize(stream::IO, ::Type{T}) where {T}
Read a `T` from the flatbuffer-formatted `stream`.
"""
function deserialize(stream::IO, ::Type{T}) where {T}
	read(T, read(stream))
end

struct UndefinedType end
const Undefined = UndefinedType()
getfieldvalue(obj::T, i) where {T} = isdefined(obj, i) ? getfield(obj, i) : Undefined
getprevfieldvalue(obj::T, i) where {T} = i == 1 ? missing : getfieldvalue(obj, i - 1)

"""
Scalar
A Union of the Julia types `T <: Number` that are allowed in FlatBuffers schema
"""
const Scalar = Union{Bool,
Int8, Int16, Int32, Int64,
UInt8, UInt16, UInt32, UInt64,
Float32, Float64}

if VERSION >= v"1.7.0-DEV.204"
	isstruct(T) = isconcretetype(T) && !ismutabletype(T)
else
	isstruct(T) = isconcretetype(T) && !T.mutable
end

isbitstype(T) = fieldcount(T) == 0
isunionwithnothing(T) = T isa Union && T.a == Nothing && !(isa(T.b, Union))

file_identifier(T) = ""
file_extension(T) = ""
slot_offsets(T) = [4 + ((i - 1) * 2) for i = 1:length(T.types)]

default(T, TT, sym) = default(TT)
default(::Type{T}) where {T <: Scalar} = zero(T)
default(::Type{T}) where {T <: AbstractString} = ""
default(::Type{T}) where {T <: Enum} = enumtype(T)(T(0))
default(::Type{Vector{T}}) where {T} = T[]

# attempt to call default constructors for the type,
# use above methods as fallback
function default(::Type{T}, i::Integer) where {T}
	TT = T.types[i]
	try
		return FlatBuffers.default(T, TT, fieldnames(T)[i])
		# catch because Parameters throws an error if there is no
		# default value defined...
	catch
	end
	return default(TT)
end

# fallback that recursively builds a default; for structs/tables
function default(::Type{T}) where {T}
	if isa(T, Union) || isa(T, UnionAll)
		return nothing
	else
		return T([default(T, i) for i = 1:length(T.types)]...)
	end
end

function typeorder end

enumtype(::Type{<:Enum}) = UInt8

# Types
"""
Table

The object containing the flatbuffer and positional information specific to the table.
The `vtable` containing the offsets for specific members precedes `pos`.
The actual values in the table follow `pos` offset and size of the vtable.

- `bytes::AbstractVector{UInt8}`: the flatbuffer itself
- `pos::Integer`:  the base position in `bytes` of the table
"""
mutable struct Table{T}
	bytes::AbstractVector{UInt8}
	pos::Integer
end

"""
Builder is a state machine for creating FlatBuffer objects.
Use a Builder to construct object(s) starting from leaf nodes.

A Builder constructs byte buffers in a last-first manner for simplicity and
performance.
"""
mutable struct Builder{T}
	bytes::AbstractVector{UInt8}
	minalign::Int
	vtable::Vector{Int}
	objectend::Int
	vtables::Vector{Int}
	head::Int
	nested::Bool
	finished::Bool
end

function hexloc(x)
	"0x" * lpad("$(string(x-1, base=16)) ", 6, '0')
end

function hexbyte(io, z)
	printstyled(io, lpad("$(string(z, base=16)) ", 3, '0'), color=Int(z))
end

function hexoffset(x)
	"0x$(lpad(string(x, base=16), 4, '0'))"
end

function stringify(io, buf, offset, x, y, msg="", msgcolor=:blue)
	y = min(y, length(buf))
	printstyled(io, hexloc(x + offset), color=:blue)
	for i = x:y
		hexbyte(io, buf[i])
	end
	if length(msg) > 0
		printstyled(io, " " * msg, color=msgcolor)
	end
	println(io)
end

function showvtable(io::IO, T, buffer, vtabstart, vtabsize)
	syms = T.name.names
	printstyled(io, "vtable start pos: $(hexoffset(vtabstart))\n", color=:green)
	printstyled(io, "vtable size: $vtabsize\n", color=:green)
	i = vtabstart + 4
	soff = slot_offsets(T)
    numslots = div(soff[end] - 4, 2) + 1
	field = 1
	slot = 1
	numfields = length(T.types)
	while slot <= numslots
		# leave holes for deprecated fields
		j = 2
		start = field == 1 ? soff[1] : soff[field - 1]
		while (start + j) < soff[field]
			# empty slot
			stringify(io, buffer, 1, i, i+1, "[deprecated field]", :red)
			slot += 1
			j += 2
			i += 2
			if (i - vtabstart) > vtabsize
				break
			end
		end
		if (i - vtabstart) > vtabsize
			break
		end
		stringify(io, buffer, 1, i, i+1, "[$(fieldnames(T)[field])]")
		slot += 1
		field += 1
		i += 2
		if (i - vtabstart) > vtabsize
			break
		end
	end
	# now we're pointing at data
	printstyled(io, "payload:\n", color=:green)
	while i < length(buffer)
		stringify(io, buffer, 1, i, i+7, "")
		i += 8
	end
end

function Base.show(io::IO, x::Union{Builder{T}, Table{T}}) where {T}
	printstyled(io, "FlatBuffers.$(typeof(x)):\n", color=:green)
	buffer = x isa Builder ? x.bytes[x.head+1:end] : x.bytes
	if isempty(buffer)
		printstyled(io, " (empty flatbuffer)", color=:red)
	else
		pos = Int(typeof(x) <: Table ? x.pos : readbuffer(buffer, 0, Int32))
		printstyled(io, "root offset: $(hexoffset(pos))\n", color=:green)
		vtaboff = readbuffer(buffer, pos, Int32)
		vtabstart = pos - vtaboff
		vtabsize = readbuffer(buffer, vtabstart, Int16)
		showvtable(io, T, buffer, vtabstart, vtabsize)
	end
end

include("internals.jl")

function Table(::Type{T}, buffer::AbstractVector{UInt8}, pos::Integer) where {T}
	return Table{T}(buffer, pos)
end

Table(b::Builder{T}) where {T} = Table(T, b.bytes[b.head+1:end], get(b, b.head, Int32))

getvalue(t, o, ::Type{Nothing}) = nothing
getvalue(t, o, ::Type{T}) where {T <: Scalar} = get(t, t.pos + o, T)
getvalue(t, o, ::Type{T}) where {T <: Enum} = T(get(t, t.pos + o, enumtype(T)))
function getvalue(t, o, ::Type{T}) where {T <: AbstractString}
	o += get(t, t.pos + o, Int32)
	strlen = get(t, t.pos + o, Int32)
	o += t.pos + sizeof(Int32)
	return String(t.bytes[o + 1:o + strlen])
end
function getvalue(t, o, ::Type{Vector{UInt8}})
	o += get(t, t.pos + o, Int32)
	len = get(t, t.pos + o, Int32)
	o += t.pos + sizeof(Int32)
	return t.bytes[o + 1:o + len] #TODO: maybe not make copy here?
end

getarray(t, vp, len, ::Type{T}) where {T <: Scalar} = (ptr = convert(Ptr{T}, pointer(t.bytes, vp + 1)); return [unsafe_load(ptr, i) for i = 1:len])
getarray(t, vp, len, ::Type{T}) where {T <: Enum} = (ptr = convert(Ptr{enumtype(T)}, pointer(t.bytes, vp + 1)); return [unsafe_load(ptr, i) for i = 1:len])
function getarray(t, vp, len, ::Type{T}) where {T <: Union{AbstractString, Vector{UInt8}}}
	A = Vector{T}(undef, len)
	for i = 1:len
		A[i] = getvalue(t, vp - t.pos, T)
		vp += sizeof(Int32)
	end
	return A
end
function getarray(t, vp, len, ::Type{T}) where {T}
	if isstruct(T)
		ptr = convert(Ptr{T}, pointer(t.bytes, vp + 1))
		return [unsafe_load(ptr, i) for i = 1:len]
	else
		A = Vector{T}(undef, len)
		for i = 1:len
			A[i] = getvalue(t, vp - t.pos, T)
			vp += sizeof(Int32)
		end
		return A
	end
end

function getvalue(t, o, ::Type{Vector{T}}) where {T}
	vl = vectorlen(t, o)
	vp = vector(t, o)
	return getarray(t, vp, vl, T)
end

Base.convert(::Type{T}, e::Integer) where {T <: Enum} = T(e)

# fallback which recursively calls read
function getvalue(t, o, ::Type{T}) where {T}
	if isstruct(T)
		if any(x-> x <: Enum, T.types)
			args = []
			o = t.pos + o + 1
			for typ in T.types
				val = unsafe_load(convert(Ptr{typ <: Enum ? enumtype(typ) : typ}, pointer(view(t.bytes, o:length(t.bytes)))))
				push!(args, val)
				o += sizeof(typ <: Enum ? enumtype(typ) : typ)
			end
			return T(args...)
		else
			return unsafe_load(convert(Ptr{T}, pointer(view(t.bytes, (t.pos + o + 1):length(t.bytes)))))
		end
	else
		o += t.pos
		newt = Table{T}(t.bytes, indirect(t, o))
		return FlatBuffers.read(newt, T)
	end
end

function typetoread(prevfield, ::Type{T}, ::Type{TT}) where {T, TT}
    R = TT
    nullable = false
    if isunionwithnothing(R)
        nullable = true
        R = TT.b
    end

    # if it's a Union type, use the previous arg to figure out the true type that was serialized
    if !isunionwithnothing(R) && R isa Union
        R = typeorder(R, prevfield)
    end

    if R <: AbstractVector
        # hacks! if it's a union all, assume it's because we're working around circular dependencies
        if isa(eltype(R), UnionAll)
            return Vector{T}, false, nullable
        # if it's a vector of Unions, use the previous field to figure out the types of all the elements
        elseif isa(eltype(R), Union)
            types = typeorder.(eltype(R), prevfield)
            R = definestruct(types)
            return R, true, nullable
        end
    end
    return R, false, nullable
end

"""
`FlatBuffers.read` parses a `T` at `t.pos` in Table `t`.
Will recurse as necessary for nested types (Arrays, Tables, etc.)
"""
function FlatBuffers.read(t::Table{T1}, ::Type{T}=T1) where {T1, T}
	args = []
	numfields = length(T.types)
	soff = slot_offsets(T)
	for i = 1:numfields
		TT = T.types[i]
		o = offset(t, soff[i])
        R, isunionvector, nullable = typetoread(i == 1 ? nothing : args[end], T, TT)
        if o == 0
            push!(args, nullable ? nothing : default(T, TT, T.name.names[i]))
        else
            if isunionvector
                R = eval(R)
                newr = Base.invokelatest(getvalue, t, o, R)
                n = length(R.types)
                push!(args, [getfieldvalue(newr, j) for j = 1:n]) 
            else
                push!(args, getvalue(t, o, R))
            end
        end
    end

	return T(args...)
end

FlatBuffers.read(::Type{T}, buffer::AbstractVector{UInt8}, pos::Integer) where {T} = FlatBuffers.read(Table(T, buffer, pos))
FlatBuffers.read(b::Builder{T}) where {T} = FlatBuffers.read(Table(T, b.bytes[b.head+1:end], get(b, b.head, Int32)))
# assume `bytes` is a pure flatbuffer buffer where we can read the root position at the beginning
FlatBuffers.read(::Type{T}, bytes) where {T} = FlatBuffers.read(T, bytes, read(IOBuffer(bytes), Int32))

has_identifier(::Type{T}, bytes) where {T} = length(bytes) >= 8 && String(bytes[5:8]) == FlatBuffers.file_identifier(T)
root_type(::Type{T}) where {T} = false

"""
flat_bytes = bytes(b)

`flat_bytes` are the serialized bytes for the FlatBuffer.  This discards the Julia specific `head`.
"""
bytes(b::Builder) = unsafe_wrap(Array{UInt8,1}, pointer(b.bytes, b.head+1), (length(b.bytes)-b.head))

function Builder(::Type{T}=Any, size=0) where {T}
	objectend = 0
	vtables = zeros(Int, 0)
	head = size
	nested = false
	bytes = zeros(UInt8, size)
	minalign = 1
	vtable = zeros(Int, 0)
	finished = false
	b = Builder{T}(bytes, minalign, vtable, objectend,
		vtables, head, nested, finished)
	return b
end

# build!
"`alignment` looks for the largest scalar member of `T` that represents a flatbuffer Struct"
function alignment(::Type{T}) where {T}
	largest = 0
	for typ in T.types
		largest = isbitstype(typ) ? max(largest,sizeof(typ)) : alignment(typ)
	end
	return largest
end

"""
`buildvector!` is for building vectors with all kinds of element types,
even building its elements recursively if needed (Array of Arrays, Array of tables, etc.).
"""
function buildvector! end

# empty vector
function buildvector!(b, A::Vector{Nothing}, len, prev)
	startvector(b, 1, 0, 1)
	return endvector(b, 0)
end
# scalar type vector
function buildvector!(b, A::Vector{T}, len, prev) where {T <: Scalar}
	startvector(b, sizeof(T), len, sizeof(T))
	foreach(x->prepend!(b, A[x]), len:-1:1)
	return endvector(b, len)
end
function buildvector!(b, A::Vector{T}, len, prev) where {T <: Enum}
	startvector(b, sizeof(enumtype(T)), len, sizeof(enumtype(T)))
	foreach(x->prepend!(b, enumtype(T)(A[x])), len:-1:1)
	return endvector(b, len)
end

function putoffsetvector!(b, offsets, len)
	startvector(b, 4, len, 4) #TODO: elsize/alignment correct here?
	foreach(x->prependoffset!(b, offsets[x]), len:-1:1)
	return endvector(b, len)
end
# byte vector vector
function buildvector!(b, A::Vector{Vector{UInt8}}, len, prev)
	offsets = map(x->createbytevector(b, A[x]), 1:len)
	return putoffsetvector!(b, offsets, len)
end
# string vector
function buildvector!(b, A::Vector{T}, len, prev) where {T <: AbstractString}
	offsets = map(x->createstring(b, A[x]), 1:len)
	return putoffsetvector!(b, offsets, len)
end
# array vector
function buildvector!(b, A::Vector{Vector{T}}, len, prev) where {T}
	offsets = map(x->buildbuffer!(b, A[x]), 1:len)
	return putoffsetvector!(b, offsets, len)
end

# make a new struct which has fields of the given type
function definestruct(types::Vector{DataType})
	fields = [:($(gensym())::$(TT)) for TT in types]
	T1 = gensym()
	eval(:(mutable struct $T1
		$(fields...)
	end))
	return T1
end

# make a new struct which has fields of the given type
# and populate them with values from the vector
function createstruct(types::Vector{DataType}, A::Vector{T}) where {T}
	T1 = definestruct(types)
	newt = Base.invokelatest(eval(T1), A...)
	return newt
end

# struct or table/object vector
function buildvector!(b, A::Vector{T}, len, prev) where {T}
	if isstruct(T)
		# struct
		startvector(b, sizeof(T), len, alignment(T)) #TODO: forced elsize/alignment correct here?
		foreach(x->buildbuffer!(b, A[x]), len:-1:1)
		return endvector(b, len)
	elseif isa(T, Union)
		types = typeorder.(T, prev)

		# define a new type, construct one, and pack it into the buffer
		newt = createstruct(types, A)
		buildbuffer!(b, newt)
	else
		# table/object
		offsets = map(x->buildbuffer!(b, A[x]), 1:len)
		return putoffsetvector!(b, offsets, len)
	end
end

"""
`getoffset` checks if a given field argument needs to be built
offset (Arrays, Strings, other tables) or can be inlined (Scalar or Struct types).
`getoffset` has a recursive nature in that it will build offset types
down to their last leaf scalar types before returning the highest-level offset.
"""
function getoffset end

getoffset(b, arg::Nothing, prev=nothing) = 0
getoffset(b, arg::T, prev=nothing) where {T <: Scalar} = 0
getoffset(b, arg::T, prev=nothing) where {T <: Enum} = 0
getoffset(b, arg::AbstractString, prev=nothing) = createstring(b, arg)
getoffset(b, arg::Vector{UInt8}, prev) = createbytevector(b, arg)
getoffset(b, arg::Vector{T}, prev) where {T} = buildbuffer!(b, arg, prev)

# structs or table/object
getoffset(b, arg::T, prev=nothing) where {T} = isstruct(T) ? 0 : buildbuffer!(b, arg, prev)

"""
`putslot!` is one of the final steps in building a flatbuffer.
It puts the final value in the "data" section of the flatbuffer,
whether that be an actual value (for `Scalar`, Struct types) or an offset
to the actual data (Arrays, Strings, other tables)
"""
function putslot! end

putslot!(b, i, arg::T, off, default, prev) where {T <: Scalar} = prependslot!(b, i, arg, default)
putslot!(b, i, arg::T, off, default, prev) where {T <: Enum} = prependslot!(b, i, enumtype(T)(arg), default)
putslot!(b, i, arg::AbstractString, off, default, prev) = prependoffsetslot!(b, i, off, 0)
putslot!(b, i, arg::Vector{T}, off, default, prev) where {T} = prependoffsetslot!(b, i, off, 0)
# structs or table/object
function putslot!(b, i, arg::T, off, default, prev) where {T}
	if isstruct(T)
		prependstructslot!(b, i, buildbuffer!(b, arg, prev), 0)
	else
		prependoffsetslot!(b, i, off, 0)
	end
end

function needreconstruct(T)
	for TT in T.types 
        if TT <: Vector && eltype(TT) isa Union && !(eltype(TT) isa UnionAll)
            return true
        elseif TT isa Union && !isunionwithnothing(TT)
            return true
        end
	end
    return false	
end

function reconstructkwargs(arg::T) where {T}
    kwargs = Dict{Symbol, Any}()
    numfields = length(T.types)
    fnames = fieldnames(T)
    for i = 2:numfields
        field = getfield(arg, i)
        prevname = fnames[i - 1]
        # hack to make the example work
        TT = field isa Vector ? eltype(field) : typeof(field)
        if :parameters in propertynames(TT) && length(TT.parameters) > 0
            TT = TT.name.wrapper
        end
        if field isa Vector && eltype(field) isa Union && !(eltype(field) isa UnionAll)
            kwargs[prevname] = [FlatBuffers.typeorder(TT, typeof(x)) for x in field]
        elseif (T.types[i] isa Union && !isunionwithnothing(T.types[i]))
            kwargs[prevname] = FlatBuffers.typeorder(T.types[i], TT)
        end
    end
    return kwargs
end

function buildbuffer!(b::Builder{T1}, arg::T, prev=nothing) where {T1<:Any, T<:Array}
    # array of things
    buildvector!(b, arg, length(arg), prev)
end

function buildbuffer!(b::Builder{T1}, arg::T, prev=nothing) where {T1<:Any, T<:Any}
    # populate the _type field before unions/vectors of unions
    if needreconstruct(T)
        # reconstruct it so the types before the fields
        # are populated correctly
        kwargs = reconstructkwargs(arg)
        arg = Parameters.reconstruct(arg; kwargs...)
    end
    if isstruct(T)
    # build a struct type with provided `arg`
        all(isstruct, T.types) || throw(ArgumentError("can't seralize flatbuffer, $T is not a pure struct"))
        align = alignment(T)
        prep!(b, align, 2align)
        for i = length(T.types):-1:1
            typ = T.types[i]
            if typ <: Enum
                prepend!(b, enumtype(typ)(getfield(arg,i)))
            elseif isbitstype(typ)
                prepend!(b, getfield(arg,i))
            else
                buildbuffer!(b, getfield(arg, i), getprevfieldvalue(arg, i))
            end
        end
        n = offset(b)
    else
        # build a table type
        # check for string/array/table types
        numfields = length(T.types)
        # early exit for empty objects
        if numfields == 0
            startobject(b, 0)
            return endobject(b)
        end
        os = Int[]
        isdefault = falses(numfields)
        for i = 1:numfields
            push!(os, getoffset(b, getfieldvalue(arg, i), getprevfieldvalue(arg, i)))
        end
        # all nested have been written, with offsets in `os[]`
        # don't use slots for the last N members if they are all default
        # also leave slots for deprecated fields
        i = numfields
        isdefault = getfieldvalue(arg, i) == default(T, i)
        while isdefault && i > 1
            i -= 1
            isdefault = getfieldvalue(arg, i) == default(T, i)
        end
        soff = slot_offsets(T)
        numslots = div(soff[i] - 4, 2) + 1
        startobject(b, numslots)
        i = 1
        field = 1
        while i <= numslots
            # leave holes for deprecated fields
            j = 2
            start = field == 1 ? soff[1] : soff[field - 1]
            while (start + j) < soff[field]
                # empty slot
                i += 1
                j += 2
            end
            val = getfieldvalue(arg, field)
            d = default(T, field)
            if !(isunionwithnothing(T.types[field]) && val == nothing)
                putslot!(b, i,
                    val,
                    os[field],
                    d,
                    getprevfieldvalue(arg, field)
                    )
            end
            field += 1
            i += 1
        end
        n = endobject(b)
    end
	return n
end

function build!(b, arg)
	n = buildbuffer!(b, arg)
	finish!(b, n)
	return b
end

build!(arg::T) where {T} = build!(Builder(T), arg)

include("macros.jl")

end # module

# automatically generated by the FlatBuffers compiler, do not modify

# module: MyGame

import FlatBuffers

mutable struct InParentNamespace
end
FlatBuffers.@ALIGN(InParentNamespace, 1)

InParentNamespace(buf::AbstractVector{UInt8}) = FlatBuffers.read(InParentNamespace, buf)
InParentNamespace(io::IO) = FlatBuffers.deserialize(io, InParentNamespace)

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import ..InParentNamespace
import FlatBuffers

FlatBuffers.@with_kw mutable struct Monster{T}
#=
#  an example documentation comment: monster object
=#
    pos::Union{Vec3, Nothing} = nothing
    mana::Int16 = 150
    hp::Int16 = 100
    name::String = ""
    inventory::Vector{UInt8} = []
    color::Color = 8
    test_type::UInt8 = 0
    test::T = nothing
    test4::Vector{Test} = []
    testarrayofstring::Vector{String} = []
#=
#  an example documentation comment: this will end up in the generated code
#  multiline too
=#
    testarrayoftables::Vector{Monster{T}} = []
    enemy::Union{Monster{T}, Nothing} = nothing
    testnestedflatbuffer::Vector{UInt8} = []
    testempty::Union{Stat, Nothing} = nothing
    testbool::Bool = false
    testhashs32_fnv1::Int32 = 0
    testhashu32_fnv1::UInt32 = 0
    testhashs64_fnv1::Int64 = 0
    testhashu64_fnv1::UInt64 = 0
    testhashs32_fnv1a::Int32 = 0
    testhashu32_fnv1a::UInt32 = 0
    testhashs64_fnv1a::Int64 = 0
    testhashu64_fnv1a::UInt64 = 0
    testarrayofbools::Vector{Bool} = []
    testf::Float32 = 3.14159
    testf2::Float32 = 3.0
    testf3::Float32 = 0.0
    testarrayofstring2::Vector{String} = []
    testarrayofsortedstruct::Vector{Ability} = []
    flex::Vector{UInt8} = []
    test5::Vector{Test} = []
    vector_of_longs::Vector{Int64} = []
    vector_of_doubles::Vector{Float64} = []
    parent_namespace_test::Union{InParentNamespace, Nothing} = nothing
    vector_of_referrables::Vector{Referrable} = []
    single_weak_reference::UInt64 = 0
    vector_of_weak_references::Vector{UInt64} = []
    vector_of_strong_referrables::Vector{Referrable} = []
    co_owning_reference::UInt64 = 0
    vector_of_co_owning_references::Vector{UInt64} = []
    non_owning_reference::UInt64 = 0
    vector_of_non_owning_references::Vector{UInt64} = []
    #= any_unique_type::UInt8 = 0 =#
    #= any_unique::AnyUniqueAliases = nothing =#
    #= any_ambiguous_type::UInt8 = 0 =#
    #= any_ambiguous::AnyAmbiguousAliases = nothing =#
    vector_of_enums::Vector{Color} = []
end
FlatBuffers.@ALIGN(Monster, 1)
FlatBuffers.slot_offsets(::Type{T}) where {T<:Monster} = [
    0x00000004, 0x00000006, 0x00000008, 0x0000000A, 
    0x0000000E, 0x00000010, 0x00000012, 0x00000014, 
    0x00000016, 0x00000018, 0x0000001A, 0x0000001C, 
    0x0000001E, 0x00000020, 0x00000022, 0x00000024, 
    0x00000026, 0x00000028, 0x0000002A, 0x0000002C, 
    0x0000002E, 0x00000030, 0x00000032, 0x00000034, 
    0x00000036, 0x00000038, 0x0000003A, 0x0000003C, 
    0x0000003E, 0x00000040, 0x00000042, 0x00000044, 
    0x00000046, 0x00000048, 0x0000004A, 0x0000004C, 
    0x0000004E, 0x00000050, 0x00000052, 0x00000054, 
    0x00000056, 0x00000058, 0x0000005A, 0x0000005C, 
    0x0000005E, 0x00000060, 0x00000062
]
FlatBuffers.root_type(::Type{T}) where {T<:Monster} = true
FlatBuffers.file_identifier(::Type{T}) where {T<:Monster} = "MONS"
FlatBuffers.file_extension(::Type{T}) where {T<:Monster} = "mon"

Monster{T}(buf::AbstractVector{UInt8}) where {T} = FlatBuffers.read(Monster{T}, buf)
Monster{T}(io::IO) where {T} = FlatBuffers.deserialize(io, Monster{T})

export @UNION, @DEFAULT, @ALIGN, @STRUCT, @with_kw

const __module__ = 0

function indexof(needle, haystack)
	for (i, v) in enumerate(haystack)
		v == needle && return i-1
	end
	return -1
end

macro UNION(T, TT)
	typeof(T) == Symbol || throw(ArgumentError("1st argument must be a symbol to represent a Union type"))
	TT.head == :tuple || throw(ArgumentError("2nd argument must be a tuple of types like `(T1,T2,...)`"))
	return esc(quote
		const $T = $(Expr(:curly, :Union, TT.args...))
		FlatBuffers.typeorder(::Type{$T}, ::Type{TT}) where {TT} = FlatBuffers.indexof(TT, $TT)
		FlatBuffers.typeorder(::Type{$T}, i::Integer) = ($TT)[i+1]
		FlatBuffers.isunionwithnothing(::Type{$T}) = false
	end)
end

macro ALIGN(T, sz)
	return esc(quote
		FlatBuffers.alignment(::Type{$T}) = $sz
	end)
end

macro enumtype(T, typ)
	return esc(quote
		FlatBuffers.enumtype(::Type{$T}) = $typ
	end)
end

# recursively finds largest field of a STRUCT
fbsizeof(::Type{T}) where {T<:Enum} = sizeof(enumtype(T))
fbsizeof(::Type{T}) where {T} = sizeof(T)

maxsizeof(::Type{T}) where {T<:Enum} = sizeof(enumtype(T))
maxsizeof(::Type{T}) where {T} = isbitstype(T) ? sizeof(T) : maximum(map(x->maxsizeof(x), T.types))

nextsizeof(::Type{T}) where {T} = isbitstype(T) ? sizeof(T) : nextsizeof(T.types[1])

function fieldlayout(mod, typ, exprs...)
	fields = Expr[]
	values = []
	largest_field = maximum(map(x->maxsizeof(Core.eval(mod, x.args[2])), exprs))
	sz = cur_sz = 0
	x = 0
	for (i,expr) in enumerate(exprs)
		T = Core.eval(mod, expr.args[2])
		if !isbitstype(T)
			exprs2 = [Expr(:(::), nm, typ) for (nm,typ) in zip(fieldnames(T),T.types)]
			fields2, values2 = fieldlayout(mod, T, exprs2...)
			append!(fields, map(x->Expr(:(::), Symbol(string(expr.args[1],'_',x.args[1])), x.args[2]), fields2))
			append!(values, map(x->x == 0 ? 0 : Expr(:call, :getfield, expr.args[1], QuoteNode(x)), values2))
		else
			push!(fields, expr)
			push!(values, expr.args[1])
		end
		sz += cur_sz = fbsizeof(T)
		if sz % largest_field == 0
			sz = cur_sz = 0
			continue
		end
		nextsz = i == length(exprs) ? 0 : nextsizeof(Core.eval(mod, exprs[i+1].args[2]))
		if i == length(exprs) || cur_sz < nextsz || (sz + nextsz) > largest_field
			# this is the last field and we're not `sz % largest_field`
			# potential diffs = 7, 6, 5, 4, 3, 2, 1
			sym = expr.args[1]
			diff = cur_sz < nextsz ? nextsz - cur_sz : largest_field - sz
			if diff == 7
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt8)); x += 1
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt16)); x += 1
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt32)); x += 1
				push!(values, 0); push!(values, 0); push!(values, 0)
			elseif diff == 6
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt16)); x += 1
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt32)); x += 1
				push!(values, 0); push!(values, 0)
			elseif diff == 5
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt8)); x += 1
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt32)); x += 1
				push!(values, 0); push!(values, 0)
			elseif diff == 4
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt32)); x += 1
				push!(values, 0)
			elseif diff == 3
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt8)); x += 1
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt16)); x += 1
				push!(values, 0); push!(values, 0)
			elseif diff == 2
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt16)); x += 1
				push!(values, 0)
			elseif diff == 1
				push!(fields, Expr(:(::), Symbol("_pad_$(sym)_$(typ)_$x"), :UInt8)); x += 1
				push!(values, 0)
			end
			sz = (sz + diff) % largest_field == 0 ? 0 : (cur_sz < nextsz ? sz + diff : 0)
			cur_sz = 0
		end
	end
	return fields, values
end

linefilter = x->typeof(x) != LineNumberNode

macro STRUCT(expr)
	!expr.args[1] || throw(ArgumentError("@STRUCT is only applicable for immutable types"))
	exprs = filter(linefilter, expr.args[3].args)
	fields, values = FlatBuffers.fieldlayout(__module__, expr.args[2], exprs...)
	expr.args[3].args = fields
	# generate convenience outer constructors if necessary
	# if there are nested structs or padding:
	# build an outer constructor that takes all direct, original fields
	# recursively flatten/splat all nested structs into one big args tuple
	# adding zeros for padded arguments
	# pass big, flat, args tuple to inner constructor
	T = expr.args[2]
	if any(x->!FlatBuffers.isbitstype(Core.eval(__module__, x.args[2])), exprs) ||
		length(fields) > length(exprs)
		exprs2 = map(x->FlatBuffers.isbitstype(Core.eval(__module__, x.args[2])) ? x.args[1] : x, exprs)
		sig = Expr(:call, T, exprs2...)
		body = Expr(:call, T, values...)
		outer = Expr(:function, sig, body)
	else
		outer = :(nothing)
	end
	return esc(quote
		$expr
		$outer
	end)
end

macro DEFAULT(T, kwargs...)
	ifblock = quote end
	if length(kwargs) > 0 && isa(kwargs[1], Expr) && length(kwargs[1].args) > 1
		for kw in kwargs
			push!(ifblock.args, :(if sym == $(QuoteNode(kw.args[1]))
				return $(kw.args[2])
			end))
		end
	end
	esc(quote
		if $T <: Enum
			FlatBuffers.default(::Type{$T}) = FlatBuffers.enumtype($T)($(kwargs[1]))
		else
			function FlatBuffers.default(::Type{$T}, TT, sym)
				$ifblock
				return FlatBuffers.default(TT)
			end
		end
	end)
end

import Parameters

function getdef(typedef::Expr)
	isstructexpr(x) = x isa Expr && x.head == :struct
	i = findfirst(x -> x isa Expr && any(isstructexpr.(x.args)), typedef.args)
	if i == nothing
		throw(ArgumentError("malformed @with_kw expression"))
	end
	wrapper = typedef.args[i]
	i = findfirst(isstructexpr, wrapper.args)
	def = wrapper.args[i]
	return def
end

function getfielddefs(typedef::Expr)
	[a for a in getdef(typedef).args[end].args if a isa Expr && a.head == :(::)]
end

function getconstructor(typedef::Expr)
	cons = getdef(typedef).args[end].args[end-1].args[1]
	typevars = []
	if :head in propertynames(cons) && cons.head == :where
		typevars = cons.args[2:end]
		cons = cons.args[1]
	end
	cons, typevars
end

function getkwtype(defs, name)
	for d in defs
		if :args in propertynames(d) && d.args[1] == name
			return d.args[end]
		end
	end
	return nothing
end

function createdefaultfns(typedef::Expr)
	cons, typevars = getconstructor(typedef)
	T = cons.args[1]
	params = cons.args[2]

	@assert params.head == :parameters

	kwargs = []
	defs = getfielddefs(typedef)
	kwdict = Dict{Any, Any}()
	for p in params.args
		name = p.args[1]
		t = getkwtype(defs, name)
		if t == nothing
			continue
		end
		value = p.args[end]
		ifblock = get(kwdict, t, quote end)
		push!(ifblock.args, :(if sym == $(QuoteNode(name))
			return convert($t, $value)
		end))
		kwdict[t] = ifblock
	end

	[:(function FlatBuffers.default(::Type{$T}, ::Type{$TT}, sym) where {$(typevars...)}
		$(kwdict[TT])
		return FlatBuffers.default($TT)
	end) for TT in keys(kwdict)]
end

macro with_kw(typedef)
	body = Parameters.with_kw(typedef, __module__, true)
	defaults = createdefaultfns(body)
	defaultsblock = Expr(:block, body, defaults...)
	esc(defaultsblock)
end

#TODO:
# handle id?
# nested_flatbuffer

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import FlatBuffers

FlatBuffers.@STRUCT struct Vec3
    x::Float32
    y::Float32
    z::Float32
    test1::Float64
    test2::Color
    test3::Test
end
FlatBuffers.@ALIGN(Vec3, 16)

Vec3(buf::AbstractVector{UInt8}) = FlatBuffers.read(Vec3, buf)
Vec3(io::IO) = FlatBuffers.deserialize(io, Vec3)

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

import ..Example2
import FlatBuffers

FlatBuffers.@UNION(Any_, (
    Nothing,
    Monster,
    TestSimpleTableWithEnum,
    Example2.Monster,
))

# automatically generated by the FlatBuffers compiler, do not modify

# module: MyGame

module MyGame
    include("InParentNamespace.jl")
    include("Example2/Example2.jl")
    include("Example/Example.jl")
end

using Documenter, FlatBuffers

makedocs(;
    modules=[FlatBuffers],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/JuliaData/FlatBuffers.jl/blob/{commit}{path}#L{line}",
    sitename="FlatBuffers.jl",
    assets=String[],
)

deploydocs(;
    repo="github.com/JuliaData/FlatBuffers.jl",
    devbranch = "main"
)

# table.go
const VtableMetadataFields = 2

const TableOrBuilder = Union{Table,Builder}

const Bytes2Type = Dict{Int, DataType}(1=>UInt8, 2=>UInt16, 4=>UInt32, 8=>UInt64)

Base.get(t::TableOrBuilder, pos, ::Type{T}) where {T} = read(IOBuffer(view(t.bytes, (pos+1):length(t.bytes))), T)
readbuffer(t::AbstractVector{UInt8}, pos::Int, ::Type{T}) where {T} = read(IOBuffer(view(t, (pos+1):length(t))), T)
Base.get(t::TableOrBuilder, pos, ::Type{T}) where {T <: Enum} = T(read(IOBuffer(view(t.bytes, (pos+1):length(t.bytes))), Bytes2Type[sizeof(T)]))

"""
`offset` provides access into the Table's vtable.

Deprecated fields are ignored by checking against the vtable's length.
"""
function offset(t::Table, vtableoffset)
	vtable = t.pos - get(t, t.pos, Int32)
	return vtableoffset < get(t, vtable, Int16) ? get(t, vtable + vtableoffset, Int16) : 0
end

"`indirect` retrieves the relative offset stored at `offset`."
indirect(t::Table, off) = off + get(t, off, Int32)

"""
`vectorlen` retrieves the length of the vector whose offset is stored at
`off` in this object.
"""
function vectorlen(t::Table, off)
	off += t.pos
	off += get(t, off, Int32)
	return get(t, off, Int32)
end

"""
`vector` retrieves the start of data of the vector whose offset is stored
at `off` in this object.
"""
function vector(t::Table, off)
	off += t.pos
	off += get(t, off, Int32)
	# data starts after metadata containing the vector length
	return off + sizeof(Int32)
end

"""
GetVOffsetTSlot retrieves the VOffsetT that the given vtable location
points to. If the vtable value is zero, the default value `d`
will be returned.
"""
function getoffsetslot(t::Table, slot, d)
	off = offset(t, slot)
	if off == 0
		return d
	end
	return off
end

"""
`getslot` retrieves the `T` that the given vtable location
points to. If the vtable value is zero, the default value `d`
will be returned.
"""
function getslot(t::Table, slot, d::T) where {T}
	off = offset(t, slot)
	if off == 0
		return d
	end

	return get(t, t.pos + off, T)
end

# builder.go
value(x::T) where {T <: Enum} = length(T.types) == 0 ? Int(x) : getfield(x,1)

Base.write(sink::Builder, o, x::Union{Bool,UInt8}) = sink.bytes[o+1] = UInt8(x)
function Base.write(sink::Builder, off, x::T) where {T}
	off += 1
	for (i,ind) = enumerate(off:(off + sizeof(T) - 1))
		sink.bytes[ind] = (x >> ((i-1) * 8)) % UInt8
	end
end
Base.write(b::Builder, o, x::Float32) = write(b, o, reinterpret(UInt32, x))
Base.write(b::Builder, o, x::Float64) = write(b, o, reinterpret(UInt64, x))
Base.write(b::Builder, o, x::Enum) = write(b, o, reinterpret(Bytes2Type[sizeof(x)], value(x)))

"Offset relative to the end of the buffer."
offset(b::Builder) = length(b.bytes) - b.head

pad!(b::Builder, n) = foreach(x->place!(b, 0x00), 1:n)

"""
`finishedbytes` returns a pointer to the written data in the byte buffer.
Panics if the builder is not in a finished state (which is caused by calling
`finish!()`).
"""
function finishedbytes(b::Builder)
	assertfinished(b)
	return b.bytes[b.head+1:end]
end

function startobject(b::Builder, numslots)
	assertnotnested(b)
	b.nested = true
	b.vtable = zeros(Int, numslots)
	b.objectend = offset(b)
	b.minalign = 1
	return b
end

"""
`endobject` writes data necessary to finish object construction.
"""
function endobject(b::Builder{T}) where {T}
	assertnested(b)
	n = writevtable!(b)
	b.nested = false
	return n
end

"""
`prep!` prepares to write an element of `size` after `additionalbytes`
have been written, e.g. if you write a string, you need to align such
the int length field is aligned to sizeof(Int32), and the string data follows it
directly.
If all you need to do is align, `additionalbytes` will be 0.
"""
function prep!(b::Builder, size, additionalbytes)
	# Track the biggest thing we've ever aligned to.
	if size > b.minalign
		b.minalign = size
	end
	# Find the amount of alignment needed such that `size` is properly
	# aligned after `additionalBytes`:
	alignsize = xor(Int(-1), (length(b.bytes) - b.head) + additionalbytes) + 1
	alignsize &= (size - 1)

	# Reallocate the buffer if needed:
	totalsize = alignsize + size + additionalbytes
	if b.head <= totalsize
		len = length(b.bytes)
		prepend!(b.bytes, zeros(UInt8, totalsize))
		b.head += length(b.bytes) - len
	end
	pad!(b, alignsize)
	return
end

"""
`prepend!` prepends a `T` to the Builder buffer.
Aligns and checks for space.
"""
function Base.prepend!(b::Builder, x::T) where {T}
	prep!(b, sizeof(T), 0)
	place!(b, x)
	return
end

"""
`place!` prepends a `T` to the Builder, without checking for space.
"""
function place!(b::Builder, x::T) where {T}
	b.head -= sizeof(T)
	write(b, b.head, x)
	return
end

"""
`startvector` initializes bookkeeping for writing a new vector.

A vector has the following format:
<UOffsetT: number of elements in this vector>
<T: data>+, where T is the type of elements of this vector.
"""
function startvector(b::Builder, elemSize, numElems, alignment)
	assertnotnested(b)
	b.nested = true
	prep!(b, sizeof(UInt32), elemSize * numElems)
	prep!(b, alignment, elemSize * numElems)
	return offset(b)
end

"""
`endvector` writes data necessary to finish vector construction.
"""
function endvector(b::Builder, vectorNumElems)
	assertnested(b)
	place!(b, UInt32(vectorNumElems))
	b.nested = false
	return offset(b)
end

"""
`createstring` writes a null-terminated string as a vector.
"""
function createstring(b::Builder, s::AbstractString)
	assertnotnested(b)
	b.nested = true
	s = codeunits(s)
	prep!(b, sizeof(UInt32), length(s) + 1)
	place!(b, UInt8(0))

	l = length(s)

	b.head -= l
	copyto!(b.bytes, b.head+1, s, 1, l)
	return endvector(b, length(s))
end

"""
`createbytevector` writes a byte vector
"""
function createbytevector(b::Builder, v::AbstractVector{UInt8})
	assertnotnested(b)
	b.nested = true

	prep!(b, sizeof(UInt32), length(v))

	l = length(v)

	b.head -= l
	copyto!(b.bytes, b.head+1, v, 1, l)

	return endvector(b, length(v))
end

"""
`prependoffset!` prepends an Int32, relative to where it will be written.
"""
function prependoffset!(b::Builder, off)
	prep!(b, sizeof(Int32), 0) # Ensure alignment is already done.
	if !(off <= offset(b))
		throw(ArgumentError("unreachable: $off <= $(offset(b))"))
	end
	off2 = offset(b) - off + sizeof(Int32)
	place!(b, Int32(off2))
	return
end

function prependoffsetslot!(b::Builder, o::Int, x::T, d) where {T}
	if x != T(d)
		prependoffset!(b, x)
		slot!(b, o)
	end
	return
end

"""
`prependslot!` prepends a `T` onto the object at vtable slot `o`.
If value `x` equals default `d`, then the slot will be set to zero and no
other data will be written.
"""
function prependslot!(b::Builder, o::Int, x::T, d) where {T}
	if x != T(d)
		prepend!(b, x)
		slot!(b, o)
	end
	return
end

"""
`prependstructslot!` prepends a struct onto the object at vtable slot `o`.
Structs are stored inline, so nothing additional is being added.
In generated code, `d` is always 0.
"""
function prependstructslot!(b::Builder, voffset, x, d)
	if x != d
		assertnested(b)
		if x != offset(b)
			throw(ArgumentError("inline data write outside of object"))
		end
		slot!(b, voffset)
	end
	return
end

"""
`slot!` sets the vtable key `voffset` to the current location in the buffer.
"""
function slot!(b::Builder, slotnum)
	b.vtable[slotnum] = offset(b)
end

"""
`finish!` finalizes a buffer, pointing to the given `rootTable`.
"""
function finish!(b::Builder{T}, rootTable) where {T}
	assertnotnested(b)
	identifier = file_identifier(T)
	n = length(identifier)
	prep!(b, b.minalign, sizeof(UInt32))
	for i = 0:(n-1)
		prepend!(b, UInt8(identifier[n - i]))
	end
	prependoffset!(b, Int32(rootTable))
	b.finished = true
	return
end

function assertnested(b::Builder)
	# If you get this assert, you're in an object while trying to write
	# data that belongs outside of an object.
	# To fix this, write non-inline data (like vectors) before creating
	# objects.
	if !b.nested
		throw(ArgumentError("Incorrect creation order: must be inside object."))
	end
	return
end

function assertnotnested(b::Builder)
	# If you hit this, you're trying to construct a Table/Vector/String
	# during the construction of its parent table (between the MyTableBuilder
	# and builder.Finish()).
	# Move the creation of these view-objects to above the MyTableBuilder to
	# not get this assert.
	# Ignoring this assert may appear to work in simple cases, but the reason
	# it is here is that storing objects in-line may cause vtable offsets
	# to not fit anymore. It also leads to vtable duplication.
	if b.nested
		throw(ArgumentError("Incorrect creation order: object must not be nested."))
	end
	return
end

function assertfinished(b::Builder)
	# If you get this assert, you're attempting to get access a buffer
	# which hasn't been finished yet. Be sure to call builder.Finish()
	# with your root table.
	# If you really need to access an unfinished buffer, use the bytes
	# buffer directly.
	if !b.finished
		throw(ArgumentError("Incorrect use of FinishedBytes(): must call 'Finish' first."))
	end
end

"""
WriteVtable serializes the vtable for the current object, if applicable.

Before writing out the vtable, this checks pre-existing vtables for equality
to this one. If an equal vtable is found, point the object to the existing
vtable and return.

Because vtable values are sensitive to alignment of object data, not all
logically-equal vtables will be deduplicated.

A vtable has the following format:
<VOffsetT: size of the vtable in bytes, including this value>
<VOffsetT: size of the object in bytes, including the vtable offset>
<VOffsetT: offset for a field> * N, where N is the number of fields in
the schema for this type. Includes deprecated fields.
Thus, a vtable is made of 2 + N elements, each SizeVOffsetT bytes wide.

An object has the following format:
<SOffsetT: offset to this object's vtable (may be negative)>
<byte: data>+
"""
function writevtable!(b::Builder{T}) where {T}
	# Prepend a zero scalar to the object. Later in this function we'll
	# write an offset here that points to the object's vtable:
	prepend!(b, Int32(0))

	objectOffset = offset(b)
	existingVtable = 0

	# Search backwards through existing vtables, because similar vtables
	# are likely to have been recently appended. See
	# BenchmarkVtableDeduplication for a case in which this heuristic
	# saves about 30% of the time used in writing objects with duplicate
	# tables.
	for i = length(b.vtables):-1:1
		# Find the other vtable, which is associated with `i`:
		vt2Offset = b.vtables[i]
		vt2Start = length(b.bytes) - vt2Offset
		vt2Len = readbuffer(b.bytes, vt2Start, Int16)

		metadata = VtableMetadataFields * sizeof(Int16)
		vt2End = vt2Start + vt2Len
		vt2 = view(b.bytes, (vt2Start + metadata + 1):vt2End) #TODO: might need a +1 on the start of range here

		# Compare the other vtable to the one under consideration.
		# If they are equal, store the offset and break:
		if vtableEqual(b.vtable, objectOffset, vt2)
			existingVtable = vt2Offset
			break
		end
	end

	if existingVtable == 0
		# Did not find a vtable, so write this one to the buffer.

		# Write out the current vtable in reverse , because
		# serialization occurs in last-first order:
		for i = length(b.vtable):-1:1
			off::Int16 = 0
			if b.vtable[i] != 0
				# Forward reference to field;
				# use 32bit number to assert no overflow:
				off = objectOffset - b.vtable[i]
			end
			prepend!(b, Int16(off))
		end

		# The two metadata fields are written last.

		# First, store the object bytesize:
		objectSize::Int16 = objectOffset - b.objectend
		prepend!(b, objectSize)

		# Second, store the vtable bytesize:
		vbytes::Int16 = (length(b.vtable) + VtableMetadataFields) * sizeof(Int16)
		prepend!(b, vbytes)

		# Next, write the offset to the new vtable in the
		# already-allocated SOffsetT at the beginning of this object:
		objectStart::Int32 = length(b.bytes) - objectOffset
		write(b, objectStart, Int32(offset(b) - objectOffset))

		# Finally, store this vtable in memory for future
		# deduplication:
		push!(b.vtables, offset(b))
	else
		# Found a duplicate vtable.

		objectStart = length(b.bytes) - objectOffset
		b.head = objectStart

		# Write the offset to the found vtable in the
		# already-allocated SOffsetT at the beginning of this object:
		write(b, b.head, Int32(existingVtable - objectOffset))
	end

	empty!(b.vtable)
	return objectOffset
end

"vtableEqual compares an unwritten vtable to a written vtable."
function vtableEqual(a::Vector{Int}, objectStart, b::AbstractVector{UInt8})
	if length(a) * sizeof(Int16) != length(b)
		return false
	end

	for i = 0:(length(a)-1)
		x = read(IOBuffer(view(b, (i * sizeof(Int16) + 1):length(b))), Int16)

		# Skip vtable entries that indicate a default value.
		x == 0 && a[i+1] == 0 && continue

		y = objectStart - a[i+1]
		x != y && return false
	end
	return true
end

# Store specific byte patterns in these variables for the fuzzer. These
# values are taken verbatim from the C++ function FuzzTest1.
const overflowingInt32Val = read(IOBuffer(UInt8[0x83, 0x33, 0x33, 0x33]), Int32)
const overflowingInt64Val = read(IOBuffer(UInt8[0x84, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44]), Int64)

# CheckByteLayout verifies the bytes of a Builder in various scenarios.
function CheckByteLayout()
	check = want-> begin
	got = b.bytes[b.head+1:end]
	@test want == got
	return
end

# test 1: numbers

b = FlatBuffers.Builder()
check(UInt8[])
FlatBuffers.prepend!(b, true)
check(UInt8[1])
FlatBuffers.prepend!(b, Int8(-127))
check(UInt8[129, 1])
FlatBuffers.prepend!(b, UInt8(255))
check(UInt8[255, 129, 1])
FlatBuffers.prepend!(b, Int16(-32222))
check(UInt8[0x22, 0x82, 0, 255, 129, 1]) # first pad
FlatBuffers.prepend!(b, UInt16(0xFEEE))
check(UInt8[0xEE, 0xFE, 0x22, 0x82, 0, 255, 129, 1]) # no pad this time
FlatBuffers.prepend!(b, Int32(-53687092))
check(UInt8[204, 204, 204, 252, 0xEE, 0xFE, 0x22, 0x82, 0, 255, 129, 1])
FlatBuffers.prepend!(b, UInt32(0x98765432))
check(UInt8[0x32, 0x54, 0x76, 0x98, 204, 204, 204, 252, 0xEE, 0xFE, 0x22, 0x82, 0, 255, 129, 1])

# test 1b: numbers 2

b = FlatBuffers.Builder()
prepend!(b, 0x1122334455667788)
check(UInt8[0x88, 0x77, 0x66, 0x55, 0x44, 0x33, 0x22, 0x11])

# test 2: 1xbyte vector

b = FlatBuffers.Builder()
check(UInt8[])
FlatBuffers.startvector(b, sizeof(Bool), 1, 1)
check(UInt8[0, 0, 0]) # align to 4bytes
FlatBuffers.prepend!(b, UInt8(1))
check(UInt8[1, 0, 0, 0])
FlatBuffers.endvector(b, 1)
check(UInt8[1, 0, 0, 0, 1, 0, 0, 0]) # padding

# test 3: 2xbyte vector

b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(UInt8), 2, 1)
check(UInt8[0, 0]) # align to 4bytes
FlatBuffers.prepend!(b, UInt8(1))
check(UInt8[1, 0, 0])
FlatBuffers.prepend!(b, UInt8(2))
check(UInt8[2, 1, 0, 0])
FlatBuffers.endvector(b, 2)
check(UInt8[2, 0, 0, 0, 2, 1, 0, 0]) # padding

# test 3b: 11xbyte vector matches builder size

b = FlatBuffers.Builder(Any, 12)
FlatBuffers.startvector(b, sizeof(UInt8), 8, 1)
start = UInt8[]
check(start)
for i = 1:11
	FlatBuffers.prepend!(b, UInt8(i))
	start = append!(UInt8[i], start)
	check(start)
end
FlatBuffers.endvector(b, 8)
check(append!(UInt8[8, 0, 0, 0], start))

# test 4: 1xuint16 vector

b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(UInt16), 1, 1)
check(UInt8[0, 0]) # align to 4bytes
FlatBuffers.prepend!(b, UInt16(1))
check(UInt8[1, 0, 0, 0])
FlatBuffers.endvector(b, 1)
check(UInt8[1, 0, 0, 0, 1, 0, 0, 0]) # padding

# test 5: 2xuint16 vector

b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(UInt16), 2, 1)
check(UInt8[]) # align to 4bytes
FlatBuffers.prepend!(b, UInt16(0xABCD))
check(UInt8[0xCD, 0xAB])
FlatBuffers.prepend!(b, UInt16(0xDCBA))
check(UInt8[0xBA, 0xDC, 0xCD, 0xAB])
FlatBuffers.endvector(b, 2)
check(UInt8[2, 0, 0, 0, 0xBA, 0xDC, 0xCD, 0xAB])

# test 6: CreateString

b = FlatBuffers.Builder()
FlatBuffers.createstring(b, "foo")
check(UInt8[3, 0, 0, 0, 'f', 'o', 'o', 0]) # 0-terminated, no pad
FlatBuffers.createstring(b, "moop")
check(UInt8[4, 0, 0, 0, 'm', 'o', 'o', 'p', 0, 0, 0, 0, # 0-terminated, 3-byte pad
	3, 0, 0, 0, 'f', 'o', 'o', 0])

# test 6b: CreateString unicode

b = FlatBuffers.Builder()
# These characters are chinese from blog.golang.org/strings
# We use escape codes here so that editors without unicode support
# aren't bothered:
uni_str = "\u65e5\u672c\u8a9e"
FlatBuffers.createstring(b, uni_str)
check(UInt8[9, 0, 0, 0, 230, 151, 165, 230, 156, 172, 232, 170, 158, 0, #  null-terminated, 2-byte pad
	0, 0])

# test 6c: CreateUInt8String

b = FlatBuffers.Builder()
FlatBuffers.createstring(b, "foo")
check(UInt8[3, 0, 0, 0, 'f', 'o', 'o', 0]) # 0-terminated, no pad
FlatBuffers.createstring(b, "moop")
check(UInt8[4, 0, 0, 0, 'm', 'o', 'o', 'p', 0, 0, 0, 0, # 0-terminated, 3-byte pad
	3, 0, 0, 0, 'f', 'o', 'o', 0])

# test 7: empty vtable
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 0)
check(UInt8[])
FlatBuffers.endobject(b)
check(UInt8[4, 0, 4, 0, 4, 0, 0, 0])

# test 8: vtable with one true bool
b = FlatBuffers.Builder()
check(UInt8[])
FlatBuffers.startobject(b, 1)
check(UInt8[])
FlatBuffers.prependslot!(b, 1, true, false)
FlatBuffers.endobject(b)
check(UInt8[
	6, 0, # vtable bytes
	8, 0, # length of object including vtable offset
	7, 0, # start of bool value
	6, 0, 0, 0, # offset for start of vtable (int32)
	0, 0, 0, # padded to 4 bytes
	1, # bool value
	])

# test 9: vtable with one default bool
b = FlatBuffers.Builder()
check(UInt8[])
FlatBuffers.startobject(b, 1)
check(UInt8[])
FlatBuffers.prependslot!(b, 1, false, false)
FlatBuffers.endobject(b)
check(UInt8[
	6, 0, # vtable bytes
	4, 0, # end of object from here
	0, 0, # entry 1 is zero
	6, 0, 0, 0, # offset for start of vtable (int32)
	])

# test 10: vtable with one int16
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 1)
FlatBuffers.prependslot!(b, 1, Int16(0x789A), Int16(0))
FlatBuffers.endobject(b)
check(UInt8[
	6, 0, # vtable bytes
	8, 0, # end of object from here
	6, 0, # offset to value
	6, 0, 0, 0, # offset for start of vtable (int32)
	0, 0, # padding to 4 bytes
	0x9A, 0x78,
	])

# test 11: vtable with two int16
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 2)
FlatBuffers.prependslot!(b, 1, Int16(0x3456), Int16(0))
FlatBuffers.prependslot!(b, 2, Int16(0x789A), Int16(0))
FlatBuffers.endobject(b)
check(UInt8[
	8, 0, # vtable bytes
	8, 0, # end of object from here
	6, 0, # offset to value 0
	4, 0, # offset to value 1
	8, 0, 0, 0, # offset for start of vtable (int32)
	0x9A, 0x78, # value 1
	0x56, 0x34, # value 0
	])

# test 12: vtable with int16 and bool
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 2)
FlatBuffers.prependslot!(b, 1, Int16(0x3456), Int16(0))
FlatBuffers.prependslot!(b, 2, true, false)
FlatBuffers.endobject(b)
check(UInt8[
	8, 0, # vtable bytes
	8, 0, # end of object from here
	6, 0, # offset to value 0
	5, 0, # offset to value 1
	8, 0, 0, 0, # offset for start of vtable (int32)
	0,          # padding
	1,          # value 1
	0x56, 0x34, # value 0
	])

# test 12: vtable with empty vector
b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(UInt8), 0, 1)
vecend = FlatBuffers.endvector(b, 0)
FlatBuffers.startobject(b, 1)
FlatBuffers.prependoffsetslot!(b, 1, UInt32(vecend), UInt32(0))
FlatBuffers.endobject(b)
check(UInt8[
	6, 0, # vtable bytes
	8, 0,
	4, 0, # offset to vector offset
	6, 0, 0, 0, # offset for start of vtable (int32)
	4, 0, 0, 0,
	0, 0, 0, 0, # length of vector (not in struct)
	])

# test 12b: vtable with empty vector of byte and some scalars
b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(UInt8), 0, 1)
vecend = FlatBuffers.endvector(b, 0)
FlatBuffers.startobject(b, 2)
FlatBuffers.prependslot!(b, 1, Int16(55), Int16(0))
FlatBuffers.prependoffsetslot!(b, 2, UInt32(vecend), UInt32(0))
FlatBuffers.endobject(b)
check(UInt8[
	8, 0, # vtable bytes
	12, 0,
	10, 0, # offset to value 0
	4, 0, # offset to vector offset
	8, 0, 0, 0, # vtable loc
	8, 0, 0, 0, # value 1
	0, 0, 55, 0, # value 0

	0, 0, 0, 0, # length of vector (not in struct)
	])

# test 13: vtable with 1 int16 and 2-vector of int16
b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(Int16), 2, 1)
FlatBuffers.prepend!(b, Int16(0x1234))
FlatBuffers.prepend!(b, Int16(0x5678))
vecend = FlatBuffers.endvector(b, 2)
FlatBuffers.startobject(b, 2)
FlatBuffers.prependoffsetslot!(b, 2, UInt32(vecend), UInt32(0))
FlatBuffers.prependslot!(b, 1, Int16(55), Int16(0))
FlatBuffers.endobject(b)
check(UInt8[
	8, 0, # vtable bytes
	12, 0, # length of object
	6, 0, # start of value 0 from end of vtable
	8, 0, # start of value 1 from end of buffer
	8, 0, 0, 0, # offset for start of vtable (int32)
	0, 0, # padding
	55, 0, # value 0
	4, 0, 0, 0, # vector position from here
	2, 0, 0, 0, # length of vector (uint32)
	0x78, 0x56, # vector value 1
	0x34, 0x12, # vector value 0
	])

# test 14: vtable with 1 struct of 1 int8, 1 int16, 1 int32
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 1)
FlatBuffers.prep!(b, 4+4+4, 0)
FlatBuffers.prepend!(b, Int8(55))
FlatBuffers.pad!(b, 3)
FlatBuffers.prepend!(b, Int16(0x1234))
FlatBuffers.pad!(b, 2)
FlatBuffers.prepend!(b, Int32(0x12345678))
structStart = FlatBuffers.offset(b)
FlatBuffers.prependstructslot!(b, 1, structStart, 0)
FlatBuffers.endobject(b)
check(UInt8[
	6, 0, # vtable bytes
	16, 0, # end of object from here
	4, 0, # start of struct from here
	6, 0, 0, 0, # offset for start of vtable (int32)
	0x78, 0x56, 0x34, 0x12, # value 2
	0, 0, # padding
	0x34, 0x12, # value 1
	0, 0, 0, # padding
	55, # value 0
	])

# test 15: vtable with 1 vector of 2 struct of 2 int8
b = FlatBuffers.Builder()
FlatBuffers.startvector(b, sizeof(Int8)*2, 2, 1)
FlatBuffers.prepend!(b, Int8(33))
FlatBuffers.prepend!(b, Int8(44))
FlatBuffers.prepend!(b, Int8(55))
FlatBuffers.prepend!(b, Int8(66))
vecend = FlatBuffers.endvector(b, 2)
FlatBuffers.startobject(b, 1)
FlatBuffers.prependoffsetslot!(b, 1, UInt32(vecend), UInt32(0))
FlatBuffers.endobject(b)
check(UInt8[
	6, 0, # vtable bytes
	8, 0,
	4, 0, # offset of vector offset
	6, 0, 0, 0, # offset for start of vtable (int32)
	4, 0, 0, 0, # vector start offset

	2, 0, 0, 0, # vector length
	66, # vector value 1,1
	55, # vector value 1,0
	44, # vector value 0,1
	33, # vector value 0,0
	])

# test 16: table with some elements
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 2)
FlatBuffers.prependslot!(b, 1, Int8(33), Int8(0))
FlatBuffers.prependslot!(b, 2, Int16(66), Int16(0))
off = FlatBuffers.endobject(b)
FlatBuffers.finish!(b, off) #TODO

check(UInt8[
	12, 0, 0, 0, # root of table: points to vtable offset

	8, 0, # vtable bytes
	8, 0, # end of object from here
	7, 0, # start of value 0
	4, 0, # start of value 1

	8, 0, 0, 0, # offset for start of vtable (int32)

	66, 0, # value 1
	0,  # padding
	33, # value 0
	])

# test 17: one unfinished table and one finished table
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 2)
FlatBuffers.prependslot!(b, 1, Int8(33), Int8(0))
FlatBuffers.prependslot!(b, 2, Int8(44), Int8(0))
off = FlatBuffers.endobject(b)
FlatBuffers.finish!(b, off)

FlatBuffers.startobject(b, 3)
FlatBuffers.prependslot!(b, 1, Int8(55), Int8(0))
FlatBuffers.prependslot!(b, 2, Int8(66), Int8(0))
FlatBuffers.prependslot!(b, 3, Int8(77), Int8(0))
off = FlatBuffers.endobject(b)
FlatBuffers.finish!(b, off)

check(UInt8[
	16, 0, 0, 0, # root of table: points to object
	0, 0, # padding

	10, 0, # vtable bytes
	8, 0, # size of object
	7, 0, # start of value 0
	6, 0, # start of value 1
	5, 0, # start of value 2
	10, 0, 0, 0, # offset for start of vtable (int32)
	0,  # padding
	77, # value 2
	66, # value 1
	55, # value 0

	12, 0, 0, 0, # root of table: points to object

	8, 0, # vtable bytes
	8, 0, # size of object
	7, 0, # start of value 0
	6, 0, # start of value 1
	8, 0, 0, 0, # offset for start of vtable (int32)
	0, 0, # padding
	44, # value 1
	33, # value 0
	])

# test 18: a bunch of bools
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 8)
FlatBuffers.prependslot!(b, 1, true, false)
FlatBuffers.prependslot!(b, 2, true, false)
FlatBuffers.prependslot!(b, 3, true, false)
FlatBuffers.prependslot!(b, 4, true, false)
FlatBuffers.prependslot!(b, 5, true, false)
FlatBuffers.prependslot!(b, 6, true, false)
FlatBuffers.prependslot!(b, 7, true, false)
FlatBuffers.prependslot!(b, 8, true, false)
off = FlatBuffers.endobject(b)
FlatBuffers.finish!(b, off)

check(UInt8[
	24, 0, 0, 0, # root of table: points to vtable offset

	20, 0, # vtable bytes
	12, 0, # size of object
	11, 0, # start of value 0
	10, 0, # start of value 1
	9, 0, # start of value 2
	8, 0, # start of value 3
	7, 0, # start of value 4
	6, 0, # start of value 5
	5, 0, # start of value 6
	4, 0, # start of value 7
	20, 0, 0, 0, # vtable offset

	1, # value 7
	1, # value 6
	1, # value 5
	1, # value 4
	1, # value 3
	1, # value 2
	1, # value 1
	1, # value 0
	])

# test 19: three bools
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 3)
FlatBuffers.prependslot!(b, 1, true, false)
FlatBuffers.prependslot!(b, 2, true, false)
FlatBuffers.prependslot!(b, 3, true, false)
off = FlatBuffers.endobject(b)
FlatBuffers.finish!(b, off)

check(UInt8[
	16, 0, 0, 0, # root of table: points to vtable offset

	0, 0, # padding

	10, 0, # vtable bytes
	8, 0, # size of object
	7, 0, # start of value 0
	6, 0, # start of value 1
	5, 0, # start of value 2
	10, 0, 0, 0, # vtable offset from here

	0, # padding
	1, # value 2
	1, # value 1
	1, # value 0
	])

# test 20: some floats
b = FlatBuffers.Builder()
FlatBuffers.startobject(b, 1)
FlatBuffers.prependslot!(b, 1, Float32(1.0), Float32(0.0))
off = FlatBuffers.endobject(b)

check(UInt8[
	6, 0, # vtable bytes
	8, 0, # size of object
	4, 0, # start of value 0
	6, 0, 0, 0, # vtable offset

	0, 0, 128, 63, # value 0
	])
end

# CheckManualBuild builds a Monster manually.
function CheckManualBuild()
	b = FlatBuffers.Builder()
	str = FlatBuffers.createstring(b, "MyMonster")

	FlatBuffers.startvector(b, 1, 5, 1)
	FlatBuffers.prepend!(b, UInt8(4))
	FlatBuffers.prepend!(b, UInt8(3))
	FlatBuffers.prepend!(b, UInt8(2))
	FlatBuffers.prepend!(b, UInt8(1))
	FlatBuffers.prepend!(b, UInt8(0))
	inv = FlatBuffers.endvector(b, 5)

	FlatBuffers.startobject(b, 13)
	FlatBuffers.prependslot!(b, 2, Int16(20), Int16(100))
	mon2 = FlatBuffers.endobject(b)

	# Test4Vector
	FlatBuffers.startvector(b, 4, 2, 1)

	# Test 0
	FlatBuffers.prep!(b, 2, 4)
	FlatBuffers.pad!(b, 1)
	FlatBuffers.place!(b, Int8(20))
	FlatBuffers.place!(b, Int16(10))

	# Test 1
	FlatBuffers.prep!(b, 2, 4)
	FlatBuffers.pad!(b, 1)
	FlatBuffers.place!(b, Int8(40))
	FlatBuffers.place!(b, Int16(30))

	# end testvector
	test4 = FlatBuffers.endvector(b, 2)

	FlatBuffers.startobject(b, 13)

	# a vec3
	FlatBuffers.prep!(b, 16, 32)
	FlatBuffers.pad!(b, 2)
	FlatBuffers.prep!(b, 2, 4)
	FlatBuffers.pad!(b, 1)
	FlatBuffers.place!(b, UInt8(6))
	FlatBuffers.place!(b, Int16(5))
	FlatBuffers.pad!(b, 1)
	FlatBuffers.place!(b, UInt8(4))
	FlatBuffers.place!(b, Float64(3.0))
	FlatBuffers.pad!(b, 4)
	FlatBuffers.place!(b, Float32(3.0))
	FlatBuffers.place!(b, Float32(2.0))
	FlatBuffers.place!(b, Float32(1.0))
	vec3Loc = FlatBuffers.offset(b)
	# end vec3

	FlatBuffers.prependstructslot!(b, 1, vec3Loc, 0) # vec3. noop
	FlatBuffers.prependslot!(b, 3, Int16(80), Int16(100))     # hp
	FlatBuffers.prependoffsetslot!(b, 4, Int32(str), Int32(0))
	FlatBuffers.prependoffsetslot!(b, 6, Int32(inv), Int32(0)) # inventory
	FlatBuffers.prependslot!(b, 8, UInt8(1), UInt8(0))
	FlatBuffers.prependoffsetslot!(b, 9, Int32(mon2), Int32(0))
	FlatBuffers.prependoffsetslot!(b, 10, Int32(test4), Int32(0))
	mon = FlatBuffers.endobject(b)

	FlatBuffers.finish!(b, mon)

	return b.bytes, b.head
end

# CheckVtableDeduplication verifies that vtables are deduplicated.
function CheckVtableDeduplication()
	b = FlatBuffers.Builder()

	FlatBuffers.startobject(b, 4)
	FlatBuffers.prependslot!(b, 1, UInt8(0), UInt8(0))
	FlatBuffers.prependslot!(b, 2, UInt8(11), UInt8(0))
	FlatBuffers.prependslot!(b, 3, UInt8(22), UInt8(0))
	FlatBuffers.prependslot!(b, 4, Int16(33), Int16(0))
	obj0 = FlatBuffers.endobject(b)

	FlatBuffers.startobject(b, 4)
	FlatBuffers.prependslot!(b, 1, UInt8(0), UInt8(0))
	FlatBuffers.prependslot!(b, 2, UInt8(44), UInt8(0))
	FlatBuffers.prependslot!(b, 3, UInt8(55), UInt8(0))
	FlatBuffers.prependslot!(b, 4, Int16(66), Int16(0))
	obj1 = FlatBuffers.endobject(b)

	FlatBuffers.startobject(b, 4)
	FlatBuffers.prependslot!(b, 1, UInt8(0), UInt8(0))
	FlatBuffers.prependslot!(b, 2, UInt8(77), UInt8(0))
	FlatBuffers.prependslot!(b, 3, UInt8(88), UInt8(0))
	FlatBuffers.prependslot!(b, 4, Int16(99), Int16(0))
	obj2 = FlatBuffers.endobject(b)

	got = b.bytes[b.head+1:end]

	want = UInt8[
	240, 255, 255, 255, # == -12. offset to dedupped vtable.
	99, 0,
	88,
	77,
	248, 255, 255, 255, # == -8. offset to dedupped vtable.
	66, 0,
	55,
	44,
	12, 0, # start of vtable
	8, 0,
	0, 0,
	7, 0,
	6, 0,
	4, 0,
	12, 0, 0, 0, # table0
	33, 0,
	22,
	11
	]

	@test got == want

	table0 = FlatBuffers.Table{Any}(b.bytes, length(b.bytes) - obj0)
	table1 = FlatBuffers.Table{Any}(b.bytes, length(b.bytes) - obj1)
	table2 = FlatBuffers.Table{Any}(b.bytes, length(b.bytes) - obj2)

	function testTable(tab, a, b, c, d)
		# vtable size
		got = FlatBuffers.getoffsetslot(tab, 0, Int16(0))
		@test 12 == got
		# object size
		got = FlatBuffers.getoffsetslot(tab, 2, Int16(0))
		@test 8 == got
		# default value
		got = FlatBuffers.getoffsetslot(tab, 4, Int16(0))
		@test a == got
		got = FlatBuffers.getslot(tab, 6, UInt8(0))
		@test b == got
		val = FlatBuffers.getslot(tab, 8, UInt8(0))
		c != val && throw(ArgumentError("failed 8, 0: $got"))
		got = FlatBuffers.getslot(tab, 10, UInt8(0))
		@test d == got
		return
	end

	testTable(table0, UInt16(0), UInt8(11), UInt8(22), UInt8(33))
	testTable(table1, UInt16(0), UInt8(44), UInt8(55), UInt8(66))
	testTable(table2, UInt16(0), UInt8(77), UInt8(88), UInt8(99))
end

# CheckNotInObjectError verifies that `endobject` fails if not inside an
# object.
function CheckNotInObjectError()
	b = FlatBuffers.Builder()

	@test_throws ArgumentError FlatBuffers.endobject(b)
end

# CheckStringIsNestedError verifies that a string can not be created inside
# another object.
function CheckStringIsNestedError()
	b = FlatBuffers.Builder()
	FlatBuffers.startobject(b, 0)
	@test_throws ArgumentError FlatBuffers.createstring(b, "foo")
end

# CheckByteStringIsNestedError verifies that a bytestring can not be created
# inside another object.
function CheckByteStringIsNestedError()
	b = FlatBuffers.Builder()
	FlatBuffers.startobject(b, 0)
	@test_throws ArgumentError FlatBuffers.createstring(b, "foo")
end

# CheckStructIsNotInlineError verifies that writing a struct in a location
# away from where it is used will cause a panic.
function CheckStructIsNotInlineError()
	b = FlatBuffers.Builder()
	FlatBuffers.startobject(b, 0)
	@test_throws ArgumentError FlatBuffers.prependstructslot!(b, 0, 1, 0)
end

# CheckFinishedBytesError verifies that `FinishedBytes` panics if the table
# is not finished.
function CheckFinishedBytesError()
	b = FlatBuffers.Builder()

	@test_throws ArgumentError FlatBuffers.finishedbytes(b)
end

function CheckCreateByteVector()
	raw = UInt8(0):UInt8(29)

	for size = 1:30
		b1 = FlatBuffers.Builder()
		b2 = FlatBuffers.Builder()
		FlatBuffers.startvector(b1, 1, size, 1)
		for i = size:-1:1
			FlatBuffers.prepend!(b1, raw[i])
		end
		FlatBuffers.endvector(b1, size)
		FlatBuffers.createbytevector(b2, raw[1:size])
		@test b1.bytes == b2.bytes
	end
end

const InitialLCGSeed = 48271
mutable struct LCG
	val::UInt32
	LCG() = new(UInt32(InitialLCGSeed))
end
reset!(lcg::LCG) = lcg.val = UInt32(InitialLCGSeed)
function next(lcg::LCG)
	n = UInt32((UInt64(lcg.val) * UInt64(279470273)) % UInt64(4294967291))
	lcg.val = n
	return n
end

# Low level stress/fuzz test: serialize/deserialize a variety of
# different kinds of data in different combinations
function checkFuzz(fuzzFields, fuzzObjects, verbose=true)

	# Values we're testing against: chosen to ensure no bits get chopped
	# off anywhere, and also be different from eachother.
	boolVal = true
	int8Val = Int8(-127) # 0x81
	uint8Val = UInt8(0xFF)
	int16Val = Int16(-32222) # 0x8222
	uint16Val = UInt16(0xFEEE)
	int32Val = Int32(overflowingInt32Val)
	uint32Val = UInt32(0xFDDDDDDD)
	int64Val = Int64(overflowingInt64Val)
	uint64Val = UInt64(0xFCCCCCCCCCCCCCCC)
	float32Val = Float32(3.14159)
	float64Val = Float64(3.14159265359)

	testValuesMax = 11 # hardcoded to the number of scalar types

	b = FlatBuffers.Builder()
	l = LCG()

	objects = fill(0, fuzzObjects)

	# Generate fuzzObjects random objects each consisting of
	# fuzzFields fields, each of a random type.
	for i = 1:fuzzObjects
		FlatBuffers.startobject(b, fuzzFields)

		for f = 1:fuzzFields
			choice = next(l) % UInt32(testValuesMax)
			if choice ==  0
				FlatBuffers.prependslot!(b, f, boolVal, false)
			elseif choice ==  1
				FlatBuffers.prependslot!(b, f, int8Val, Int8(0))
			elseif choice ==  2
				FlatBuffers.prependslot!(b, f, uint8Val, UInt8(0))
			elseif choice ==  3
				FlatBuffers.prependslot!(b, f, int16Val, Int16(0))
			elseif choice ==  4
				FlatBuffers.prependslot!(b, f, uint16Val, UInt16(0))
			elseif choice ==  5
				FlatBuffers.prependslot!(b, f, int32Val, Int32(0))
			elseif choice ==  6
				FlatBuffers.prependslot!(b, f, uint32Val, UInt32(0))
			elseif choice ==  7
				FlatBuffers.prependslot!(b, f, int64Val, Int64(0))
			elseif choice ==  8
				FlatBuffers.prependslot!(b, f, uint64Val, UInt64(0))
			elseif choice ==  9
				FlatBuffers.prependslot!(b, f, float32Val, Float32(0))
			elseif choice ==  10
				FlatBuffers.prependslot!(b, f, float64Val, Float64(0))
			end
		end

		off = FlatBuffers.endobject(b)

		# store the offset from the end of the builder buffer,
		# since it will keep growing:
		objects[i] = off
	end

	# Do some bookkeeping to generate stats on fuzzes:
	stats = Dict{String,Int}()
	function check(desc, want, got)
		v = get!(stats, desc, 0)
		stats[desc] = v + 1
		@test want == got
	end

	l = LCG() # Reset.

	# Test that all objects we generated are readable and return the
	# expected values. We generate random objects in the same order
	# so this is deterministic.
	for i = 1:fuzzObjects

		table = FlatBuffers.Table{Any}(b.bytes, length(b.bytes) - objects[i])

		for j = 0:(fuzzFields - 1)
			f = (FlatBuffers.VtableMetadataFields + j) * sizeof(Int16)
			choice = next(l) % UInt32(testValuesMax)

			if choice == 0
				check("bool", boolVal, FlatBuffers.getslot(table, f, false))
			elseif choice == 1
				check("int8", int8Val, FlatBuffers.getslot(table, f, Int8(0)))
			elseif choice == 2
				check("uint8", uint8Val, FlatBuffers.getslot(table, f, UInt8(0)))
			elseif choice == 3
				check("int16", int16Val, FlatBuffers.getslot(table, f, Int16(0)))
			elseif choice == 4
				check("uint16", uint16Val, FlatBuffers.getslot(table, f, UInt16(0)))
			elseif choice == 5
				check("int32", int32Val, FlatBuffers.getslot(table, f, Int32(0)))
			elseif choice == 6
				check("uint32", uint32Val, FlatBuffers.getslot(table, f, UInt32(0)))
			elseif choice == 7
				check("int64", int64Val, FlatBuffers.getslot(table, f, Int64(0)))
			elseif choice == 8
				check("uint64", uint64Val, FlatBuffers.getslot(table, f, UInt64(0)))
			elseif choice == 9
				check("float32", float32Val, FlatBuffers.getslot(table, f, Float32(0)))
			elseif choice == 10
				check("float64", float64Val, FlatBuffers.getslot(table, f, Float64(0)))
			end
		end
	end

	# If enough checks were made, verify that all scalar types were used:
	if fuzzFields*fuzzObjects >= testValuesMax
		if length(stats) != testValuesMax
			throw(ArgumentError("fuzzing failed to test all scalar types"))
		end
	end

	# Print some counts, if needed:
	if verbose
		if fuzzFields == 0 || fuzzObjects == 0
			println("fuzz\tfields: $fuzzFields \tobjects: $fuzzObjects \t[none]\t 0")
		else
			ks = sort!(collect(keys(stats)))
			for k in ks
				println("fuzz\tfields: $fuzzFields \tobjects: $fuzzObjects \t$(k): $(stats[k])")
			end
		end
	end
	return
end

# automatically generated by the FlatBuffers compiler, do not modify

# module: Example

module Example
    include("Color.jl")
    include("Test.jl")
    include("Vec3.jl")
    include("Stat.jl")
    include("Ability.jl")
    include("Referrable.jl")
    include("TestSimpleTableWithEnum.jl")
    # include("AnyUniqueAliases.jl")
    # include("AnyAmbiguousAliases.jl")
    include("Monster.jl")
    include("Any_.jl")
    include("TypeAliases.jl")
end

# FlatBuffers.jl Documentation

#### Overview
FlatBuffers.jl provides native Julia support for reading and writing binary structures following the google flatbuffer schema (see [here](https://google.github.io/flatbuffers/flatbuffers_internals.html) for a more in-depth review of the binary format).

The typical language support for flatbuffers involves utilizing the `flatc` compiler to translate a flatbuffer schema file (.fbs) into a langugage-specific set of types/classes and methods. See [here](https://google.github.io/flatbuffers/flatbuffers_guide_writing_schema.html) for the official guide on writing schemas.

This Julia package contains serialization primitives and a minimal set of macros which provide flatbuffer-compatible serialization of existing Julia types. This has led to the Julia code appearing somewhat more readable than for other languages.

For example, for this schema:
```
namespace example;

table SimpleType {
  x: int = 1;
}

root_type SimpleType;
```
the corresponding Julia looks like this:
```julia
module Example

using FlatBuffers
@with_kw mutable struct SimpleType
    x::Int32 = 1
end

# ... other generated stuff
end
```
You can pepper your existing Julia types with these macros and then call the functions below to produce flatbuffer-compatible
binaries.

#### Usage
`FlatBuffers` provides the following functions for reading and writing flatbuffers:
```
FlatBuffers.serialize(stream::IO, value::T) 
FlatBuffers.deserialize(stream::IO, ::Type{T})
```
These methods are not exported to avoid naming clashes with the `Serialization` module.
For convenience, there are also two additional constructors defined for each generated type:
* `T(buf::AbstractVector{UInt8}, pos::Integer=0)`
* `T(io::IO)`

Here is an example showing how to use them to serialize the example type above.
```julia
import FlatBuffers, Example

# create an instance of our type
val = Example.SimpleType(2)

# serialize it to example.bin
open("example.bin", "w") do f FlatBuffers.serialize(f, val) end

# read the value back again from file
val2 = open("example.bin", "r") do f
  FlatBuffers.deserialize(f, Example.SimpleType)
end
```
In addition, this package provides the following types and methods, which are useful
when inspecting and constructing flatbuffers:
* `FlatBuffers.Table{T}` - type for deserializing a Julia type `T` from a flatbuffer
* `FlatBuffers.Builder{T}` - type for serializing a Julia type `T` to a flatbuffer
* `FlatBuffers.read` - performs the actual deserializing on a `FlatBuffer.Table`
* `FlatBuffers.build!` - performs the actual serializing on a `FlatBuffer.Builder`

#### Additional Methods
For a type `T` it is also possible to define:
* `FlatBuffers.file_extension(T)` - returns the `file_extension` specified in the schema (if any)
* `FlatBuffers.file_identifier(T)` - returns the `file_identifier` specified in the schema (if any)
* `FlatBuffers.has_identifier(T, bytes)` - returns whether the given bytes contain the identifier for `T` at the offset designated by the flatbuffers specification
* `FlatBuffers.slot_offsets(T)` - an array containing the positions of the slots in the vtable for type `T`, accounting for gaps caused by deprecated fields
* `FlatBuffers.root_type(T)` - returns whether the type is designated as the root type by the schema. Also note however that no `root_type` definition is necessary in Julia; any of the generated `mutable struct`s can be a valid root table type.

#### State of flatc integration
It was hoped that support for Julia could be added to `flatc`, however this is difficult with the current approach due to 
https://github.com/JuliaLang/julia/issues/269. This package will require a rethink, or potentially a completely separate package may be created. The most up-to-date fork of `flatc` with support for Julia may be found here:
https://github.com/rjkat/flatbuffers-julia

#### Advanced utilities
Documentation is also included for many
internal methods and may be queried using `?` at the REPL.
* `@ALIGN T size_in_bytes` - convenience macro for forcing a flatbuffer alignment on the Julia type `T` to `size_in_bytes`
* `@with_kw mutable struct T fields...` - convenience macro for defining default field values for Julia type `T`
* `@UNION T Union{T1,T2,...}` - convenience macro for defining a flatbuffer union type `T`
* `@STRUCT struct T fields... end` - convenience macro for defining flatbuffer struct types, ensuring any necessary padding gets added to the type definition
